;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;

;LED |[g5
LED1	.BEQU 0,PDR5		;P50
LED2	.BEQU 1,PDR5		;P51

bitLED1	.EQU 0				;P50
bitLED2	.EQU 1				;P51

;ICMR
MLS		.BEQU 7,ICMR
WAIT	.BEQU 6,ICMR

;ICCR
ICE		.BEQU 7,ICCR
IEIC	.BEQU 6,ICCR
MST		.BEQU 5,ICCR
TRS		.BEQU 4,ICCR
ACKE	.BEQU 3,ICCR
BBSY	.BEQU 2,ICCR
IRIC	.BEQU 1,ICCR
SCP		.BEQU 0,ICCR

;ICSR
ESTP	.BEQU 7,ICSR
STOP	.BEQU 6,ICSR
IRTR	.BEQU 5,ICSR
AASX	.BEQU 4,ICSR
AL		.BEQU 3,ICSR
AAS		.BEQU 2,ICSR
ADZ		.BEQU 1,ICSR
ACKB	.BEQU 0,ICSR

;CCR
CY		.EQU	B'00000001			;CY flag
Z		.EQU	B'00000100			;Z flag

;I2C
SCL		.BEQU 7,PDR5
SDA		.BEQU 6,PDR5

bitSCL	.EQU 7
bitSDA	.EQU 6


;SPI
SCK		.BEQU	7,PDR5 		;P57
SDI		.BEQU	6,PDR5 		;P56
SDO		.BEQU	0,PDR1 		;P10

bitSCK	.EQU	7 			;P57
bitSDI	.EQU	6 			;P56
bitSDO	.EQU	0 			;P10

;1-Wire
bitDQ	.EQU	7			;P57
bitSPU	.EQU	6			;P56

DQ		.BEQU	7,PDR5		;P57
SPU		.BEQU	6,PDR5		;P56


;LCD
LCD_E	.BEQU 7,PDR8		;P87
LCD_RS	.BEQU 6,PDR8		;P86
LCD_RW	.BEQU 2,PDR1		;P12

bitE	.EQU 7				;P87
bitRS	.EQU 6				;P86
bitRW	.EQU 2				;P12
