;
; }CR1 2 3C^[tF[Xp 5
;	copyright(c) T.Nakao 2007
;		07/07/25 eւ
;
; AvP[V2
;	I2C H8\tgEFAE}X^ EEPROM
;	XCb`ǉ AhXAf[^SWőI
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\common\\ComDef.inc>
	INCLUDE <..\\common\\I2CSM.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\Delay.inc>
	INCLUDE <..\\common\\AppFnc.inc>

	__CONFIG 0x3F72

	GLOBAL arg1, arg2

	radix	dec

	UDATA
arg1	RES 1
arg2	RES 1
key		RES 1

rom_adr_H	RES 1
rom_adr_L	RES 1
rom_data	RES 1


RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

START:
;	CALL copy_init_data

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0	;LED1
	BCF		TRISC, 1	;LED2

	CALL	LCDInit		;LCD
	CALL	I2CMsInit	;I2C
	CALL	InitBtn		;{^

	LED1_OFF
	LED2_OFF

MainLoop:
	CALL	ScanBtn		;{^̓XL
	;
	CALL	GetBtn
	IORLW	0
	BZ		next1		;͂ȂƂ
	BANKSEL	key
	MOVWF	key			;̓R[hۑ
	DECF	key
	BZ		j_btn1
	DECF	key
	BZ		j_btn2
	DECF	key
	BZ		j_btn3
	;
	; j_btn4			;Btn4̏ LCDNA
	CALL	LCDClear	;LCDNAs
	LED1_OFF
	LED2_OFF
	GOTO	next1

j_btn1:					;Btn1̏
	CALL	GetSWRomAdrs	;SWɂIꂽROMAhX
	BANKSEL	arg1
	MOVFW	arg1			;ROMʃAhX
	MOVWF	rom_adr_H
	MOVFW	arg2			;ROMʃAhX
	MOVWF	rom_adr_L
	;
	CALL	GetSWData		;SWɂIꂽROMf[^
	BANKSEL	rom_data
	MOVWF	rom_data		;ROMf[^

	;---------------------------------
	;X^[gRfBVs
	;---------------------------------
	MOVLW	0
	CALL	I2CStart

	;---------------------------------
	;Rg[oCgM
	;---------------------------------
	MOVLW	0xA0		;CB(W) I2CAhX=0x50, R/W=0
	CALL	I2CWrite	;CBM

	;---------------------------------
	;f[^M(ROMAhXH)
	;---------------------------------
	MOVFW	rom_adr_H
	CALL	I2CWrite	;ROMAhX

	;---------------------------------
	;f[^M(ROMAhXL)
	;---------------------------------
	MOVFW	rom_adr_L
	CALL	I2CWrite	;ROMAhX

	;---------------------------------
	;f[^M(ROMf[^)
	;---------------------------------
	MOVFW	rom_data
	CALL	I2CWrite	;ROMf[^

	;---------------------------------
	;XgbvRfBVs
	;---------------------------------
	CALL	I2CStop		;XgbvRfBV

	;
	GOTO	next1


j_btn2:					;Btn2̏ I2C}X^M
	CALL	GetSWRomAdrs	;SWɂIꂽROMAhX
	BANKSEL	arg1
	MOVFW	arg1			;ROMʃAhX
	MOVWF	rom_adr_H
	MOVFW	arg2			;ROMʃAhX
	MOVWF	rom_adr_L

	;---------------------------------
	;X^[gRfBVs
	;---------------------------------
	MOVLW	0
	CALL	I2CStart

	;---------------------------------
	;Rg[oCgM
	;---------------------------------
	MOVLW	0xA0		;CB(W) I2CAhX=0x50, R/W=0
	CALL	I2CWrite	;CBM

	;---------------------------------
	;f[^M(ROMAhXH)
	;---------------------------------
	MOVFW	rom_adr_H
	CALL	I2CWrite	;ROMAhX

	;---------------------------------
	;f[^M(ROMAhXL)
	;---------------------------------
	MOVFW	rom_adr_L
	CALL	I2CWrite	;ROMAhX

	;---------------------------------
	;s[gEX^[gRfBVs
	;---------------------------------
	MOVLW	1
	CALL	I2CStart

	;---------------------------------
	;Rg[oCgM
	;---------------------------------
	MOVLW	0xA1		;CB(W) I2CAhX=0x50, R/W=1
	CALL	I2CWrite	;CBM

	;---------------------------------
	;f[^M(ROMf[^)
	;---------------------------------
	MOVLW	1				;NOACK
	CALL	I2CRead			;1oCgM(2nd)
	CALL	LCDPrint2Hexa	;LCD2oCgڂ\

	;---------------------------------
	;XgbvRfBVs
	;---------------------------------
	CALL	I2CStop		;XgbvRfBV

	GOTO	next1

j_btn3:					;Btn3̏
	GOTO	next1


next1:
	GOTO	MainLoop


INTERRUPT:
	RETFIE

	END
