;
; }CR1 2 3C^[tF[Xp 7
;	copyright(c) T.Nakao 2007
;
; I2Cn[hEFAX[uEAvP[V
;	hCo eXg
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\common\\ComDef.inc>
	INCLUDE <..\\common\\I2CHS.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\Delay.inc>
	INCLUDE <..\\common\\AppFnc.inc>

	__CONFIG 0x3F72

	GLOBAL arg1, arg2
	GLOBAL SlaveInit, SlaveSend, SlaveReceive	;Cxgnh

	radix	dec

	UDATA
arg1	RES 1
arg2	RES 1
RcvData RES 1
key		RES 1

tmp1	RES	1
tmp2	RES 1
TxDat2st	RES 1
SeqCnt	RES 1

RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

START:
;	CALL copy_init_data

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0	;LED1
	BCF		TRISC, 1	;LED2

	CALL	LCDInit		;LCD
	CALL	InitBtn		;{^

	CALL	GetSWAdrs	;X[uAhXXibvSW擾

	CALL	I2CSlInit	;I2C(MSSP SLAVE)

	BANKSEL	SSPADD
	MOVFW	SSPADD
	CALL	LCDPrint2Hexa	;AhXLCD֕\

MainLoop:
	CALL I2CSlCom		;X[u

	CALL	ScanBtn		;{^̓XL
	CALL	GetBtn		;{^R[h擾
	IORLW	0
	BZ		next1		;͂ȂƂ
	BANKSEL	key
	MOVWF	key			;̓R[hۑ
	DECF	key
	BZ		j_btn1
	DECF	key
	BZ		j_btn2
	DECF	key
	BZ		j_btn3
	;
	; j_btn4			;Btn4̏ LCDNA
	CALL	LCDClear	;LCDNAs
	LED1_OFF
	LED2_OFF
	GOTO	next1

j_btn1:					;Btn1̏ I2CX[uM
	GOTO	next1

j_btn2:					;Btn2̏ I2CX[u
	GOTO	next1

j_btn3:					;Btn3̏
	GOTO	next1


next1:
	GOTO	MainLoop


;****************************************
; I2CX[uCBMCxgEnh
;   I2C̃X[uAhX(CB)MƂ
;   s(V[PX̎n܂)
;	  OUT W:MRg[EoCg
;****************************************
SlaveInit:
	BANKSEL	SeqCnt
	CLRF	SeqCnt
	RETURN


;****************************************
; I2CX[uMCxgEnh
;   I2C̃X[uM邽тɌĂяo鏈
;	1oCgM̂(M)ɌĂяo
;	  IN W:Mf[^
;****************************************
SlaveReceive:
	;
	; LCDɎMf[^\
	;
	GOTO	LCDPrint2Hexa	;LCD1oCg16i2ŕ\


;****************************************
; I2CX[uMCxgEnh
;   I2C X[uMOɌĂяo鏈
;	1oCgM̂(MO)ɌĂяo
;	  OUT W:ɑMf[^
;****************************************
SlaveSend:

	BANKSEL	SeqCnt
	MOVFW	SeqCnt
	IORLW	0
	BZ		j_1st		;1oCgڂ̑M
	;
	; 2nd
	BANKSEL	TxDat2st
	MOVFW	TxDat2st	;2oCgڂ̑Mf[^W
	RETURN

	;
	;1oCgڂ̑M
	;
j_1st:
	BANKSEL	SeqCnt
	INCF	SeqCnt		;2oCgڂɐݒ

	CALL	GetSWData	;Mf[^XibvSW擾
	BANKSEL	tmp1
	MOVWF	tmp1

	COMF	tmp1, W		;rbg]
	BANKSEL	TxDat2st
	MOVWF	TxDat2st	;2oCgڂ̃f[^Ƃĕۑ

	BANKSEL	tmp1
	MOVFW	tmp1		;̑Mf[^W

	RETURN


INTERRUPT:
	RETFIE


	END
