;
; }CR1 2 3C^[tF[Xp 8
;	copyright(c) T.Nakao 2007
;
; I2C\tgEFAX[uEhCo eXgpAvP[V
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\common\\ComDef.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\Delay.inc>
	INCLUDE <..\\common\\AppFnc.inc>
	INCLUDE <..\\common\\I2CSS.inc>		;I2C\tgEFAEX[uEhCo

	__CONFIG 0x3F72

	GLOBAL	arg1, arg2

	GLOBAL	SlaveInit, SlaveReceive, SlaveSend		;061014

	radix	dec

	UDATA
arg1    RES 1
arg2    RES 1
RcvData RES 1
key		RES 1
rslt		RES	1
tmp		RES	1
DtIndex	RES	1				;061014

RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

START:
;	CALL	copy_init_data

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0		;LED1
	BCF		TRISC, 1		;LED2

	LED1_OFF
	LED2_OFF

	CALL	LCDInit			;LCD
	CALL	InitBtn			;{^

	CALL	GetSWAdrs		;X[uAhXXibvSW擾
	CALL	I2CSlInit		;I2CX[u

MainLoop:
	CALL	I2CSlCom
	GOTO	MainLoop


;****************************************
; I2CX[uCBMCxgEnh
;   I2C̃X[uAhX(CB)MƂ
;   s(V[PX̎n܂)
;	  IN W(܂CBbyte):MRg[EoCg
;****************************************
SlaveInit:
	CALL	LCDClear		;LCDNA
	BANKSEL	CByte
	BTFSC	CByte, 0		;CBR/Wrbg
	GOTO	jj
	;
	; W(X[uM)
	BANKSEL	CByte
	MOVFW	CByte
	CALL	LCDPrint2Hexa	;CB\
	RETURN

	; R(X[uM)
jj:
	MOVLW	'S'
	CALL	LCDPutc
	MOVLW	'l'
	CALL	LCDPutc
	MOVLW	'S'
	CALL	LCDPutc
	MOVLW	'n'
	CALL	LCDPutc
	MOVLW	'd'
	CALL	LCDPutc
	BANKSEL	DtIndex
	CLRF	DtIndex			;M̂
	RETURN

;****************************************
; I2CX[uMCxgEnh
;   I2C̃X[uM邽тɌĂяo鏈
;	1oCgM̂(M)ɌĂяo
;	  IN W:Mf[^
;****************************************
SlaveReceive:
	CALL	LCDPrint2Hexa		;\(WɎMf[^Ă)
	RETURN


;****************************************
; I2CX[uMCxgEnh
;   I2C X[uMOɌĂяo鏈
;	1oCgM̂(MO)ɌĂяo
;	  OUT W:ɑMf[^
;****************************************
SlaveSend:
	BANKSEL	DtIndex
	CLRW
	IORWF	DtIndex, W
	BNZ		j_2ndTxdat
	;
	; 1oCgڂ̑Mf[^
	CALL	GetSWData		;XibvXCb`Ilǂ
	BANKSEL	I2CTxData
	MOVWF	I2CTxData		;Mf[^ݒ
	INCF	DtIndex, F		;Mf[^̃CfbNXXV
	RETURN

	; 2oCgڂ̑Mf[^
j_2ndTxdat:
	CALL	GetSWData		;XibvXCb`Ilǂ
	BANKSEL	tmp
	MOVWF	tmp
	COMF	tmp, W			;␔
	MOVWF	I2CTxData
	RETURN


INTERRUPT:
	RETFIE


	END
