;
; }CR1 2 3C^[tF[Xp 12
;	copyright(c) T.Nakao 2007
;
; SPI\tgEFAX[uEAvP[V
;	hCo eXg
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\AppFnc.inc>
	INCLUDE <..\\common\\SPISMS.inc>		;SPI\tgEFAE}X^/X[u

	__CONFIG 0x3F72

	GLOBAL	arg1, arg2

	radix	dec

	UDATA
key	RES	1
arg1	RES	1
arg2	RES	1


RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

START:

Main:
	BANKSEL	TRISC
	BCF		TRISC, 0			;LED1
	BCF		TRISC, 1			;LED2

	LED1_OFF
	LED2_OFF

	CALL	LCDInit				;LCD
	CALL	InitBtn				;{^
	CALL	SPISlInit			;SPIX[u


MainLoop:
	CALL	GetSWData			;gOXCb`f[^I
	MOVWF	SPITxData			;X[uMf[^ݒ

	CALL	SPISlCom			;X[uM
	IORLW	0
	BZ		nx1					;܂ʐMĂȂƂ
	;
	;ʐM
;;	CALL	LCDClear			;LCDNAs
	MOVFW	SPIRxData			;X[uMf[^
	CALL	LCDPrint2Hexa		;LCD֎Mf[^\

nx1:
	CALL	ScanBtn				;{^̓XL
	;
	CALL	GetBtn
	IORLW	0
	BZ		MainLoop			;͂ȂƂ
	BANKSEL	key
	MOVWF	key					;̓R[hۑ
	DECF	key
	BZ		j_btn1
	DECF	key
	BZ		j_btn2
	DECF	key
	BZ		j_btn3
	;
	;j_btn4						;Btn4̏ LCDNA
	CALL	LCDClear			;LCDNAs
	LED1_OFF
	LED2_OFF
	GOTO	MainLoop

j_btn1:
j_btn2:					;
j_btn3:					;
	GOTO	MainLoop


INTERRUPT:
	RETFIE

	END
