;
; }CR1 2 3C^[tF[Xp 13
;	copyright(c) T.Nakao 2007
;
; One-Wire vWFNg3
;	1-Wirevg^CvEhCo eXgpAvP[V
;		xǂݏo(ROMR[hw)
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>

	__CONFIG 0x3F72

	GLOBAL arg1, arg2

	EXTERN OneWireInit, OWBusReset, OWWriteByte, OWReadByte
	EXTERN OWCrc, CrcBuf, CrcCnt

	radix	dec

	UDATA
; local
arg1    RES 1
arg2    RES 1
owdata	RES 9
cnt		RES 1
ptr		RES	1
ptr2	RES	1


RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

INTERRUPT:
	RETFIE

START:
;	CALL	copy_init_data

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0		;LED1
	BCF		TRISC, 1		;LED2

	LED1_OFF
	LED2_OFF
	CALL	LCDInit			;LCD

	CALL	OneWireInit		;1-wire 

	;-------------------------------------
	; oXEZbg
	;-------------------------------------
	CALL	OWBusReset
	IORLW	0
	BZ		j1			;v[XpX񌟏o
	LED1_ON				;v[XpXo
	;
j1:
	;-------------------------------------
	; }b`ROMR}h
	;   DT7`DT0̐ݒl͎ۂɓǂݏoROMR[h
	;   Ă.̂܂܂ł͍쓮܂.
	;-------------------------------------
	;
	; ROMR[hݒ
	BANKSEL	owdata
	MOVLW	0x10			; DT7
	MOVWF	owdata
	;
	MOVLW	0x27			; DT6
	MOVWF	owdata + 1
	;
	MOVLW	0xB0			; DT5
	MOVWF	owdata + 2
	;
	MOVLW	0xD8			; DT4
	MOVWF	owdata + 3
	;
	MOVLW	0x00			; DT3
	MOVWF	owdata + 4
	;
	MOVLW	0x08			; DT2
	MOVWF	owdata + 5
	;
	MOVLW	0x00			; DT1
	MOVWF	owdata + 6
	;
	MOVLW	0xEC			; DT0
	MOVWF	owdata + 7
	;
	; }b`ROMR}hM
	MOVLW	0x55			;MATCH ROM command
	CALL	OWWriteByte		;R}hM
	;
	; ROMR[hM
	MOVLW	8
	MOVWF	cnt				;[v8
	;
	MOVLW	owdata			;ROMR[hi[̐擪AhX
	MOVWF	ptr				;|C^ݒ
	;
lp2:
	MOVFW	ptr
	MOVWF	FSR
	INCF	ptr, F			;̃AhX(̏)
	;
	MOVFW	INDF			;1oCgo
	CALL	OWWriteByte		;ROMR[hM
	;
	BANKSEL	cnt
	DECFSZ	cnt
	GOTO	lp2				;8JԂ
	;
	;-------------------------------------
	; CONVERT T R}h
	;-------------------------------------
	;
	MOVLW	0x44			;CONVERT T command
	CALL	OWWriteByte		;R}hM
	;
	;
;	;750ms҂
;	BANKSEL cnt
;	MOVLW	750/5			;[v
;	MOVWF	cnt
;lp3:
;	CALL	DELAY_5ms
;	BANKSEL cnt
;	DECFSZ	cnt
;	GOTO	lp3
	;
	;ϊI҂
	;
lp3:
	CALL	OWReadByte		;[hXbg(ϊ0)
	IORLW	0
	BZ		lp3				;ϊI܂Ń[v

	;
	;
	;-------------------------------------
	; oXZbg
	;-------------------------------------
	CALL	OWBusReset
	;
	;-------------------------------------
	; }b`ROMR}h
	;-------------------------------------
	MOVLW	0x55			;MATCH ROM command
	CALL	OWWriteByte		;R}hM
	;
	; ROMR[hM
	MOVLW	8
	MOVWF	cnt				;[v8
	;
	MOVLW	owdata			;ROMR[hi[̐擪AhX
	MOVWF	ptr				;|C^ݒ
	;
lp22:
	MOVFW	ptr
	MOVWF	FSR
	INCF	ptr, F			;̃AhX(̏)
	;
	MOVFW	INDF			;1oCgo
	CALL	OWWriteByte		;ROMR[hM
	;
	BANKSEL	cnt
	DECFSZ	cnt
	GOTO	lp22				;8JԂ
	;
	;
	;-------------------------------------
	; [hXNb`pbhR}h
	;-------------------------------------
	MOVLW	0xBE			;READ SCRATCHPAD command
	CALL	OWWriteByte		;R}hM
	;
	; XNb`pbhǂݏo
	BANKSEL	cnt
	MOVLW	9				;XNb`pbh̃oCg
	MOVWF	cnt
	;
	MOVLW	owdata			;Mf[^i[̐擪AhX
	MOVWF	ptr				;|C^ݒ
	;
lp4:
	MOVFW	ptr
	MOVWF	FSR
	INCF	ptr, F			;̃AhX(̏)
	CALL	OWReadByte		;ǂݏo
	MOVWF	INDF			;ۑ
	;
	DECFSZ	cnt
	GOTO	lp4				;9oCgJԂ

	;
	;-------------------------------------------------
	;ǂݏoXNb`pbh(CRC)LCD֕\
	;-------------------------------------------------
	; LCD 1ڂɍŏ4oCg
	MOVLW	4
	BANKSEL	cnt
	MOVWF	cnt
	MOVLW	owdata		;AhX
	MOVWF	ptr			;|C^ݒ
	;
lp5:
	BANKSEL	ptr
	MOVFW	ptr
	MOVWF	FSR
	INCF	ptr, F
	MOVFW	INDF
	CALL	LCDPrint2Hexa
	;
	MOVLW	','
	CALL	LCDPutc
	;
	BANKSEL	cnt
	DECFSZ	cnt, F
	GOTO lp5
	;
	; LCD 2ڂɎc4oCg
	MOVLW	4
	BANKSEL	cnt
	MOVWF	cnt

	MOVLW	0
	MOVWF	CurX
	MOVLW	1
	MOVWF	CurY
	CALL	LCDGotoXY
lp6:
	BANKSEL	ptr
	MOVFW	ptr
	MOVWF	FSR
	INCF	ptr, F
	MOVFW	INDF
	CALL	LCDPrint2Hexa
	MOVLW	','
	CALL	LCDPutc

	BANKSEL	cnt
	DECFSZ	cnt, F
	GOTO lp6

	;-------------------------------------
	; CRC
	;-------------------------------------
	; XNb`pbh̓e(9oCg)
	;   CRCvZpobt@(CrcBuf)ɃRs[
	MOVLW	9
	BANKSEL	cnt
	MOVWF	cnt
	MOVLW	owdata		;\[XEAhX
	MOVWF	ptr			;|C^ݒ
	;
	MOVLW	CrcBuf		;fBXeBl[VEAhX
	MOVWF	ptr2		;|C^ݒ
lp7:
	MOVFW	ptr
	MOVWF	FSR
	MOVFW	INDF		;1oCgo
	MOVWF	owdata
	INCF	ptr, F
	;
	MOVFW	ptr2
	MOVWF	FSR
	MOVFW	owdata
	MOVWF	INDF		;1oCgۑ
	INCF	ptr2, F
	;
	DECFSZ	cnt
	GOTO	lp7

	; CRCvZ
	MOVLW	9				;CRCvZΏۂ̃oCg
	MOVWF	CrcCnt
	CALL	OWCrc			;CRCvZW
	CALL	LCDPrint2Hexa	;ʕ\

	GOTO $

	END
