;
; }CR1 2 3C^[tF[Xp 13
;	copyright(c) T.Nakao 2007
;
; One-Wire vWFNg5
;	1-Wirevg^CvEhCo eXgpAvP[V
;		ROMR[h
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\Delay.inc>

	__CONFIG 0x3F72

	GLOBAL arg1, arg2

	EXTERN OneWireInit, OWBusReset, OWWriteByte, OWReadByte
	EXTERN OWCrc, CrcBuf, CrcCnt

	EXTERN	OWRomSearch, OWGetRomBit, OWSetRomBit, OWClearRom
	EXTERN	OWRead1Slot, OWWrite1Slot, OWReSearch
	EXTERN	RomCode, OWDviceCnt

	radix	dec

	UDATA
; local
arg1    RES 1
arg2    RES 1
owdata	RES 9
cnt		RES 1
ptr		RES	1
ptr2	RES	1
cnt2	RES 1
cnt3	RES 1
srsts	RES	1


RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

INTERRUPT:
	RETFIE

START:
;	CALL	copy_init_data

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0		;LED1
	BCF		TRISC, 1		;LED2

	LED1_OFF
	LED2_OFF
	CALL	LCDInit			;LCD

	CALL	OneWireInit		;1-wire 
	;
	;-------------------------------------------------
	; ROM
	;-------------------------------------------------
	BANKSEL	cnt2
	LDLF	2, cnt2
	;
	CALL	OWRomSearch	;ROM()
	BANKSEL	srsts
	MOVWF	srsts		;sʂۑ
	;
lpp2:
	;
	;-------------------------------------------------
	;ǂݏoROMR[hLCD֕\
	;-------------------------------------------------
	; LCD 1ڂɍŏ4oCg
	MOVLW	4
	BANKSEL	cnt
	MOVWF	cnt
	MOVLW	RomCode		;AhX
	MOVWF	ptr			;|C^ݒ
	;
lp5:
	MOVFW	ptr
	MOVWF	FSR
	INCF	ptr, F
	BANKISEL	ptr
	MOVFW	INDF
	CALL	LCDPrint2Hexa
	;
	MOVLW	','
	CALL	LCDPutc
	;
	BANKSEL	cnt
	DECFSZ	cnt, F
	GOTO lp5
	;
	; LCD 2ڂɎc4oCg
	MOVLW	4
	BANKSEL	cnt
	MOVWF	cnt

	MOVLW	0
	MOVWF	CurX
	MOVLW	1
	MOVWF	CurY
	CALL	LCDGotoXY
lp6:
	BANKSEL	ptr
	BANKISEL	ptr			;060909
	MOVFW	ptr
	MOVWF	FSR
	INCF	ptr, F
	MOVFW	INDF
	CALL	LCDPrint2Hexa
	MOVLW	','
	CALL	LCDPutc

	BANKSEL	cnt
	DECFSZ	cnt, F
	GOTO lp6

	;-------------------------------------
	; CRC
	;-------------------------------------
	; ROMR[h̓e(8oCg)
	;   CRCvZpobt@(CrcBuf)ɃRs[
	MOVLW	8
	BANKSEL	cnt
	MOVWF	cnt
	MOVLW	RomCode		;\[XEAhX
	MOVWF	ptr			;|C^ݒ
	;
	MOVLW	CrcBuf		;fBXeBl[VEAhX
	MOVWF	ptr2		;|C^ݒ
lp7:
	MOVFW	ptr
	MOVWF	FSR
	BANKISEL	ptr		;060909
	MOVFW	INDF		;1oCgo
	MOVWF	owdata
	INCF	ptr, F
	;
	MOVFW	ptr2
	MOVWF	FSR
	MOVFW	owdata
	MOVWF	INDF		;1oCgۑ
	INCF	ptr2, F
	;
	DECFSZ	cnt
	GOTO	lp7

	; CRCvZ
	MOVLW	8				;CRCvZΏۂ̃oCg
	MOVWF	CrcCnt
	CALL	OWCrc			;CRCvZW
	CALL	LCDPrint2Hexa	;ʕ\

	;-------------------------------------
	;fBC
	;-------------------------------------
	BANKSEL	cnt3
	LDLF	250, cnt3
lp10:
	CALL	Delay5ms
	BANKSEL	cnt3
	DECFSZ	cnt3, F
	GOTO	lp10

	BANKSEL	cnt3
	LDLF	250, cnt3
lp11:
	CALL	Delay5ms
	BANKSEL	cnt3
	DECFSZ	cnt3, F
	GOTO	lp11

	;-------------------------------------
	; ̌̏
	;-------------------------------------
	CALL	LCDClear

	BANKSEL	srsts
	MOVFW	srsts			;̎s
	SUBLW	2				;̎c`FbN
	BZ		lpp				;̃foCX̌
	;
	GOTO $					;I

lpp:
	CALL	OWReSearch		;ROM(2߈ȍ~)
	BANKSEL	srsts
	MOVWF	srsts			;sʂۑ
	GOTO	lpp2

	END
