;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
; fBC [`
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>

	GLOBAL	w5us, tmp_delay5us
	GLOBAL	Delay1ms, Delay5ms, Delay10us

	radix	dec

	UDATA
; global
tmp_delay5us	RES 1

dtmp1	RES 1
dtmp2	RES 1
dtmp3	RES 1



	CODE

;*************************************************
; 5usPʂ̃fBCETu[`(Clock=20MHz)
;*************************************************
lp:
	NOP		;NOP x 5
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	;
w5us:
	NOP		;NOP x 15
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	DECFSZ	tmp_delay5us, F
	GOTO lp
	RETURN


;***********************************************
; delay 10us(clock=20MHz)
;***********************************************
Delay10us:
	;(WAIT5us 10)
	MOVLW	2					;10/5
	BANKSEL	tmp_delay5us
	MOVWF	tmp_delay5us
	GOTO	w5us


;	RETURN


;***********************************************
; delay 1ms(clock=20MHz)
;***********************************************
Delay1ms:
	;(WAIT5us 1000)
	MOVLW	200					;1000/5
	BANKSEL	tmp_delay5us
	MOVWF	tmp_delay5us
	GOTO	w5us



;***********************************************
; delay 5ms(clock=20MHz)
;***********************************************
Delay5ms:
	BANKSEL	dtmp3
	LDLF 	5, dtmp3
dl3:
	CALL	Delay1ms
	DECFSZ	dtmp3
	GOTO	dl3

	RETURN


	END
