;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
; I2Cn[hEFAX[uEhCo
;

	LIST	 p=16f877a
	INCLUDE	<p16F877a.inc>
	INCLUDE	<..\\common\\ComDef.inc>

	GLOBAL	I2CSlInit, I2CSlCom
	EXTERN	SlaveInit, SlaveSend, SlaveReceive	;Cxgnh

	radix	dec

; [Jϐ
	UDATA
tmp1	RES 1

; O[oϐ

	CODE

;****************************************
; I2C(MSSPgp) X[u 7bit mode
;   IN W X[uAhX
;****************************************
I2CSlInit:
	BANKSEL	TRISC
	BSF		TRISC, 3			;SCL input
	BSF		TRISC, 4			;SDA input

	BANKSEL	SSPCON
	BCF		SSPCON, SSPM3		;SSPM3-0:0110
	BSF		SSPCON, SSPM2
	BSF		SSPCON, SSPM1
	BCF		SSPCON, SSPM0
	BSF		SSPCON, CKP			;NbNXgb`

	BANKSEL	SSPSTAT
	BSF		SSPSTAT, SMP		;X[[g100MHz
	BCF		SSPSTAT, CKE

	BANKSEL	tmp1
	MOVWF	tmp1
	BCF		STATUS, C
	RLF		tmp1
	MOVFW	tmp1
	BANKSEL	SSPADD
	MOVWF	SSPADD				;X[uAhX(W)

	BANKSEL	SSPCON2
	BSF		SSPCON2, SEN		;MNbNXgb`L

	BSF		SSPCON2, GCEN		;WFlER[EAhX

	BANKSEL	SSPCON
	BSF		SSPCON, SSPEN		;MSSP enable(ŌɎs邱)

	BCF		SSPCON, WCOL
	BCF		SSPCON, SSPOV

	RETURN


;****************************************
; I2CX[u(MSSPgp) 7bit mode
;****************************************
I2CSlCom:
	BANKSEL	PIR1
	BTFSS	PIR1, SSPIF
	RETURN						;I2C̃CxgȂ
	;

	BANKSEL	SSPSTAT
	BTFSS	SSPSTAT, D_A
	GOTO	j_addrcv			;(1)AhXM
	;
	BTFSS	SSPSTAT, R_W
	GOTO	j_datrcv			;(3)f[^ X[uM
	;
	; (2)f[^ X[uM(2oCgڈȍ~)
	;
	CALL	SlaveSend			;MȌ(WɑMf[^pӂ)
	BANKSEL	SSPBUF
	MOVWF	SSPBUF				;Mf[^SSPBUFɐݒ
	;
	BANKSEL	SSPCON
	BSF		SSPCON, CKP			;NbNXgb`
	CLR_SSPIF
	RETURN

j_addrcv:						;(1)AhXM
	BANKSEL	SSPBUF
	MOVFW	SSPBUF				;[h(BFZbg邽)
	CALL	SlaveInit			;CBMCxgnh
	BANKSEL	SSPSTAT
	BTFSS	SSPSTAT, R_W
	GOTO	j_end				;X[uMȂ̂őMf[^͐ݒ͂Ȃ
	;
	; X[uMȂ̂őMf[^ݒ肷
	;
	CALL	SlaveSend			;X[uMCxgnh
								;MȌ(WɑMf[^pӂ)
	BANKSEL	SSPBUF
	MOVWF	SSPBUF				;Mf[^SSPBUFɐݒ
	GOTO	j_end				;NbNXgb`ďI

j_datrcv:						;(3)f[^ X[uM
	BANKSEL	SSPBUF
	MOVFW	SSPBUF				;Mf[^o(BFNA)
	CALL	SlaveReceive		;X[uMCxgnh
	;							;f[^MƂ̏
j_end:
	CLR_SSPIF
	BANKSEL	SSPCON
	BSF		SSPCON, CKP			;NbNXgb`
	RETURN

	END
