;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
; SPI n[hEFA쓮}X^^X[uEhCo
;

	LIST	 p=16f877a
	INCLUDE	<p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>

	GLOBAL	SPIMsInit, SPIMsCom
	GLOBAL	SPISlInit, SPISlCom
	GLOBAL	SPITxData, SPIRxData

	radix	dec

; SPI|[g
SCK	EQU 3		;RC3
SDI	EQU 4		;RC4
SDO	EQU 5		;RC5
SS	EQU 5		;RA5


	UDATA

SPITxData	RES	1	;Mf[^
SPIRxData	RES	1	;Mf[^

	CODE

;****************************************
; SPI}X^(MSSPgp)
;****************************************
SPIMsInit:
	BANKSEL	SSPCON
	BCF		SSPCON, SSPM3		;SSPM3-0:0001
	BCF		SSPCON, SSPM2
	BCF		SSPCON, SSPM1
	BSF		SSPCON, SSPM0

	BANKSEL	SSPSTAT
	BCF		SSPSTAT, SMP		;
	BCF		SSPSTAT, CKE


	BANKSEL	SSPCON
	BCF		SSPCON, CKP
	BSF		SSPCON, SSPEN		;MSSP enable(ŌɎs邱)

	BANKSEL	TRISC
	BCF		TRISC, SCK			;clock output
	BSF		TRISC, SDI
	BCF		TRISC, SDO
	BSF		TRISA, SS

;	BANKSEL	PIE1
;	BSF		PIE1, SSPIE
;	BSF		INTCON, PEIE
;	BSF		INTCON, GIE


	BANKSEL SSPCON
	BCF		SSPCON, WCOL
	BCF		SSPCON, SSPOV

	RETURN


;****************************************
; SPI}X^M(MSSPgp)
;  IN:  SPITxData }X^Mf[^
;  OUT: SPIRxData }X^Mf[^
;****************************************
SPIMsCom:
	BANKSEL	SPITxData
	MOVFW	SPITxData

	BANKSEL	SSPBUF
	MOVWF	SSPBUF		;}X^M

	WAIT_SSPIF			;SSPIFZbg(ʐM)҂
	MOVFW	SSPBUF		;}X^M Mf[^W
	BANKSEL	SPIRxData
	MOVWF	SPIRxData
	CLR_SSPIF

	RETURN


;****************************************
; SPIX[u(MSSPgp)
;****************************************
SPISlInit:
	BANKSEL	SSPCON
	BCF		SSPCON, SSPM3		;SSPM3-0:0101
	BSF		SSPCON, SSPM2
	BCF		SSPCON, SSPM1
	BSF		SSPCON, SSPM0

	BANKSEL	SSPSTAT
	BCF		SSPSTAT, SMP		;
	BCF		SSPSTAT, CKE


	BANKSEL	SSPCON
	BCF		SSPCON, CKP
	BSF		SSPCON, SSPEN		;MSSP enable(ŌɎs邱)

	BANKSEL	TRISC
	BSF		TRISC, SCK			;clock input
	BSF		TRISC, SDI
	BCF		TRISC, SDO
	BSF		TRISA, SS

	BANKSEL SSPCON
	BCF		SSPCON, WCOL
	BCF		SSPCON, SSPOV

	BANKSEL	SSPBUF
	LDLF	0, SSPBUF		;ԏ߂ɑM_~[f[^ݒ

	RETURN


;****************************************
; SPIX[uM(MSSPgp)
;   IN:  SPITxData X[uMf[^
;   OUT: SRIRxData X[uMf[^
;   OUT: W 1:true(ʐM)/0:false(ʐMȂ)
;****************************************
SPISlCom:

	;SSPIFZbg(ʐM)҂ ĂȂƂ͂ɏI
	BANKSEL PIR1
	BTFSS	PIR1, SSPIF
	RETLW	0				;false

	BANKSEL	SSPBUF
	MOVFW	SSPBUF			;Mf[^o
	;
	MOVWF	SPIRxData		;Mf[^ۑ
	MOVFW	SPITxData		;̑Mf[^擾
	;
	MOVWF	SSPBUF			;Mf[^pӂĎ̎Mɔ

	CLR_SSPIF

	RETLW	1				;true


	END
