//
// }CR1 2 3C^[tF[Xp 14
//	copyright(c) T.Nakao 2007
//
//   1-Wire \tgEFAX[uEAvP[V
//

#case	// 啶ʂ

#include "main145.h"
#include <string.h>
#include <ctype.h>

#include "..\Common\def877a.h"		// 877p}N`(p)
#include "..\Common\reg877a.h"		// 877pWX^`(p)
#include "..\Common\OW.c"			// 1-Wire}X^hCo
#include "..\Common\LCD_custom.c"	// LCDhCo

void LCDString(char *str);

// BYTE RomCode[8];

void main() {
	BYTE i;
	char strbuf[16];
	BYTE crc, sts;

	ADCON1 = 0x06;				// ADC All digital
	lcd_init();					// LCD
	OWInit();					// 1-wire 

	delay_ms(500);

	// ROM
	sts = OWRomSearch();		// ROM()

	while(1) {
		if(sts != 0) {
			// 
//			lcd_gotoxy(1, 1);		// J[\ݒ
			lcd_putc('\f');			// LCDNA

			for(i = 0; i < 4; i++) {
				sprintf(strbuf, "%02X ", RomCode[i]);
				LCDString(strbuf);
			}
			lcd_putc('\n');
			for(; i < 8; i++) {
				sprintf(strbuf, "%02X ", RomCode[i]);
				LCDString(strbuf);
			}
			crc = OWCrc(RomCode, 8);
			sprintf(strbuf, "%02X ", crc);
			LCDString(strbuf);
		}
		if(sts == 2) {
			// c
			delay_ms(2000);
			sts = OWReSearch();
		} else {
			break;					// [v𔲂
		}
	}
	delay_ms(2000);
	lcd_putc('\f');			// LCDNA
}

//
// LCD\
//
void LCDString(char *str) {
	while(*str != 0) {
		lcd_putc(*str);
		str++;
	}
}
