//
// }CR1 2 3C^[tF[Xp
//	copyright(c) T.Nakao 2007
//
//	ʊ֐
//

void UpdateClock(void);
void CmdProc(char ch);
char KeyCheck(BYTE key, BYTE repeat_ena);
char KeyCheck2(BYTE key);
char GetRxData(BYTE *data);


// ------------------------------------------------------------------
// vXV TYPE2 061212
// ------------------------------------------------------------------
BYTE Hour = 0;
BYTE Min = 0;
BYTE Sec = 0;
BYTE Day = 0;
WORD MinClock = 0;

void UpdateClock2(void) {
	// vXV
	Sec++;
	if(Sec >= 60) {
		Sec = 0;
		Min++;
		if(Min >= 60) {
			Min = 0;
			Hour++;
			if(Hour >= 24) {
				Hour = 0;
				Day++;			// 061212
			}
		}
		MinClock++;
		if(MinClock >= 24*60) {
			MinClock = 0;
		}
	}
}


// ------------------------------------------------------------------
// VAR}h,s
// ------------------------------------------------------------------
#define CMDBUF_SIZE 12
char CmdBuf[CMDBUF_SIZE];		// VAR}hobt@
BYTE CPtr;						// VAR}hobt@̑}ʒu

void SerCmdExec(void);

//
// VAR}h,s
//
void CmdProc(char ch) {
	switch(ch) {
		case '\b':						// BS
			if(CPtr > 0) {
				CPtr--;					// obt@1폜
				printf("\b \b");
			}
			break;
		case '\r':				// Enter(R}hm)
			if(CPtr < CMDBUF_SIZE) {
				// ܂R}hobt@ɓo^łƂ
				CmdBuf[CPtr] = 0x00;	// NULLR[h
				printf("\n\r");			// s
				SerCmdExec();			// R}h͂Ďs
			}
			CPtr = 0;					// R}hobt@NA
			break;
		case ' ':	// (SP)͂̃LZ
			CPtr = 0;					// obt@ɂ
			printf("\n\r");				// s
			break;
		case '\n':
			break;
		default:
#ifdef ECHO_BACK
			putc(ch);				// GR[obN
#endif
			if(CPtr < CMDBUF_SIZE-1) {
				// ܂R}hobt@ɓo^łƂ
				CmdBuf[CPtr] = ch;		// R}ho^
				CPtr++;					// ̓o^ʒu(ɔ)
			} else {
				// R}hobt@t̂Ƃ
				CPtr = 0;				// obt@ɂ
				printf("?\n\r");		// s
			}
			break;
	}
}


// ------------------------------------------------------------------
// L[`FbNA`^OAs[g
// ------------------------------------------------------------------

BYTE BefKey = 0;
BYTE KPValue;
BYTE KeyMatch = 0;
bool KeyDown = false;
bool Repeating = false;
BYTE KeyInterval = 0;

#define KEY_REPEAT_ENA true
#define KEY_REPEAT_DIS false

char KeyCheck(BYTE key, BYTE repeat_ena) {
	if(BefKey == key) {
		KeyMatch++;
		if(KeyMatch > 50) {
			KeyMatch = 50;		// 20ms * 50 = 1s
			Repeating = true;
		} else {
			Repeating = false;
		}
	} else {
		BefKey = key;
		KeyMatch = 0;
		Repeating = false;
	}
	if(KeyMatch >= 2) {
		if(key == 0xFF) {
			// ͂Ȃm(Key Up)
			KeyDown = false;
			Repeating = false;
		} else {
			// L[͊m(Key Down)
			if(!Repeating) {
				// s[głȂ
				if(!KeyDown) {
					// ܂L[͂m肵ĂȂƂ
					KeyDown = true;
					KPValue = key;
					return true;
				}
			} else {
				// s[g
				KeyInterval = (KeyInterval + 1) % 10;
				if(KeyInterval == 0) {
					KeyDown = true;
					KPValue = key;
					return true;
				}
			}
		}
	}
	return false;
}


// ------------------------------------------------------------------
// L[`FbNA`^OAs[g TYPE2 061214
//   key0̂ݗƂɊmAΉ
// ------------------------------------------------------------------
BYTE KeepCnt = 0;				// JE^(Key0)
bool keyz = false;				// key0tO()

char KeyCheck2(BYTE key) {
	if(BefKey == key) {
		KeyMatch++;
		if(KeyMatch > 50) {
			KeyMatch = 50;		// 20ms * 50 = 1s
			Repeating = true;
		} else {
			Repeating = false;
		}
	} else {
		BefKey = key;
		KeyMatch = 0;
		Repeating = false;
	}
	if(KeyMatch >= 3) {
		if(key == 0xFF) {
			// ͂Ȃm(Key Up)
			KeepCnt = 0;				// JE^NA
			Repeating = false;
			KeyDown = false;
			if(keyz) {
				// Okey=0
				keyz = false;
				KPValue = 0;
				return true;
			}
		} else {
			// L[͊m(Key Down)
			if(!Repeating) {
				// s[głȂ
				if(!KeyDown) {
					if(key != 0) {
						// ܂L[͂m肵ĂȂƂ
						KeyDown = true;
						KPValue = key;
						return true;
					} else {
						KeyDown = true;
						keyz = true;
					}
				}
			} else {
				// s[g
				keyz = false;
				KeyInterval = (KeyInterval + 1) % 10;
				if(KeyInterval == 0) {
					if(key != 0) {
						KeyDown = true;
						KPValue = key;
						return true;
					} else {
						// key=0̂Ƃ
						KeepCnt++;
						// `FbN
						if(KeepCnt == 2) {
							// o
							KPValue = key + 0x80;
							return true;			// m
						} else if(KeepCnt > 2) {
							// 2bȍ~͖
							KeepCnt--;
						}			// mO͓͂m
									// ĂĂfalse(Ƃtrue)
					}
				}
			}
		}
	}
	return false;
}


// ------------------------------------------------------------------
// VAM Oobt@1o
// ------------------------------------------------------------------
#define RXBUFSIZE 16
BYTE RcSts;
BYTE RcvBuf[RXBUFSIZE];		// MpOobt@
BYTE RcvInPtr = 0;
BYTE RcvOutPtr = 0;
signed char RcvCnt = 0;

char GetRxData(BYTE *data) {
	if(RcvCnt > 0) {
		*data = RcvBuf[RcvOutPtr++];	// Oobt@1oCgo
		DI_GLOBAL;
		RcvCnt--;						// ێXV
		EI_GLOBAL;
		if(RcvOutPtr >= RXBUFSIZE) {
			RcvOutPtr = 0;				// bvAEh
		}
		return true;
	} else {
		*data = 0;
		return false;					// Oobt@̏ꍇ
	}
}
