//
// }CR1 2 3C^[tF[Xp
//	copyright(c) T.Nakao 2007
//
//	I2Cn[hEFAX[uEhCo
//


// vg^Cv錾
void SlaveInit(BYTE dat);
void SlaveReceive(BYTE dat);
BYTE SlaveSend(void);


//****************************************
// I2C(MSSPgp) X[u 7bit mode
//   IN  adrs:X[uAhX
//****************************************
void I2CSlInit(BYTE adrs) {
	BitSet(TRISC, 3);			// SCL input
	BitSet(TRISC, 4);			// SDA input

	BitClr(SSPCON, SSPM3);		// SSPM3-0:0110
	BitSet(SSPCON, SSPM2);
	BitSet(SSPCON, SSPM1);
	BitClr(SSPCON, SSPM0);
	BitSet(SSPCON, CKP);		// NbNXgb`

	BitSet(SSPSTAT, SMP);		// X[[g100MHz
	BitClr(SSPSTAT, CKE);

	SSPADD = adrs << 1;			// X[uAhXl,LSB=0

	BitSet(SSPCON2, SEN);		// MNbNXgb`L
	BitSet(SSPCON2, GCEN);		// WFlER[EAhX
	BitSet(SSPCON, SSPEN);		// MSSP enable(ŌɎs邱)

	BitClr(SSPCON, WCOL);
	BitClr(SSPCON, SSPOV);
}


//****************************************
// I2CX[u(MSSPgp) 7bit mode
//****************************************
void I2CSlCom(void) {
	BYTE dat;

	if(!TST_SSPIF) {
		return;
	}

	if(!BitTst(SSPSTAT, D_A)) {
		// (1)AhXM
		dat = SSPBUF;					// Mf[^o(BFNA)
		SlaveInit(dat);					// CBMƂ̏

		if(BitTst(SSPSTAT, R_W)) {
			// X[uMȂ̂őMf[^ݒ肷
			dat = SlaveSend();			// MȌ(WɑMf[^pӂ)
			SSPBUF = dat;				// Mf[^SSPBUFɐݒ
		}
	} else {
		if(BitTst(SSPSTAT, R_W)) {
			// (2)f[^ X[uM(2oCgڈȍ~)
			dat = SlaveSend();			// MȌ
			SSPBUF = dat;				// Mf[^SSPBUFɐݒ
		} else {
			// (3)f[^ X[uM
			dat = SSPBUF;				// Mf[^o(BFNA)
			SlaveReceive(dat);			// f[^MƂ̏
		}
	}

	CLR_SSPIF;
	BitSet(SSPCON, CKP);				// NbNXgb`
}
