;
; }CR1 2 3C^[tF[Xp 5
;	copyright(c) T.Nakao 2007
;
; AvP[V1
;	I2C H8\tgEFAE}X^ EEPROM
;	hCo[`, ŒlR/W
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\common\\ComDef.inc>
	INCLUDE <..\\common\\I2CSM.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\Delay.inc>

	__CONFIG 0x3F72

	GLOBAL arg1, arg2

	radix	dec

	UDATA
arg1    RES 1
arg2    RES 1
RcvData RES 1


RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

START:
MAIN:
	CALL	LCDInit		;LCD
	CALL	I2CMsInit	;I2C

 	;------------- I2C-EEPROM݃eXg --------------
	MOVLW	0
	CALL	I2CStart	;X^[gRfBV
	;
	MOVLW	0xA0		;CB(W)
	CALL	I2CWrite
	;
	MOVLW	0x01		;ROM Address(H)
	CALL	I2CWrite
	;
	MOVLW	0x23		;ROM Address(L)
	CALL	I2CWrite
	;
	MOVLW	0x75		;ROM Data
	CALL	I2CWrite
	;
	CALL	I2CStop		;XgbvRfBV

	CALL	Delay5ms	;EEPROM݊҂
	CALL	Delay5ms

	BANKSEL	RcvData	;UNAĂ
	LDLF	0, RcvData

	;------------- I2C-EEPROMǏoeXg --------------
	MOVLW	0
	CALL	I2CStart	;X^[gRfBV

	MOVLW	0xA0		;CB(W)
	CALL	I2CWrite
	;
	MOVLW	0x01		;ROM Address(H)
	CALL	I2CWrite
	;
	MOVLW	0x23		;ROM Address(L)
	CALL	I2CWrite
	;
	MOVLW	1			;repeat
	CALL	I2CStart	;s[gX^[gRfBV

	MOVLW	0xA1		;CB(R)
	CALL	I2CWrite
	;
	MOVLW	1			;NOACK
	CALL	I2CRead
	BANKSEL	RcvData
	MOVWF	RcvData		;Mf[^ۑ
	;
	CALL	I2CStop		;XgbvRfBV

 	;---------- LCD\eXg I2CǏof[^\ ----------
	BANKSEL	RcvData
	MOVF	RcvData, W			;I2CMf[^𕜋A
	CALL	LCDPrint2Hexa		;LCD֕\

	GOTO	$					;HALT

INTERRUPT:
	RETFIE

	END
