;
; }CR1 2 3C^[tF[Xp 8
;	copyright(c) T.Nakao 2007
;
; H8 I2CᑬŃ\tgEFAE}X^EAvP[V
;	I2C\tgEFAX[u eXgp̃}X^
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\common\\ComDef.inc>
	INCLUDE <..\\common\\I2CSM2.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\Delay.inc>
	INCLUDE <..\\common\\AppFnc.inc>

	__CONFIG 0x3F72

	GLOBAL arg1, arg2

	radix	dec

	UDATA
arg1	RES 1
arg2	RES 1
key		RES 1

tmp1	RES	1
tmp2	RES 1

RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

START:

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0	;LED1
	BCF		TRISC, 1	;LED2

	CALL	LCDInit		;LCD
	CALL	I2CMsInit	;I2C
	CALL	InitBtn		;{^

	LED1_OFF
	LED2_OFF

MainLoop:
	CALL	ScanBtn		;{^̓XL
	;
	CALL	GetBtn
	IORLW	0
	BZ		next1		;͂ȂƂ
	BANKSEL	key
	MOVWF	key			;̓R[hۑ
	DECF	key
	BZ		j_btn1
	DECF	key
	BZ		j_btn2
	DECF	key
	BZ		j_btn3
	;
	; j_btn4			;Btn4̏ LCDNA
	CALL	LCDClear	;LCDNAs
	LED1_OFF
	LED2_OFF
	GOTO	next1

j_btn1:					;Btn1̏ I2C}X^M
	CALL	GetSWAdrs	;MX[uEAhXXibvSW擾
	BANKSEL	tmp2
	MOVWF	tmp2		;AhX
	;
	CALL	GetSWData	;Mf[^XibvSW擾
	BANKSEL	tmp1
	MOVWF	tmp1		;f[^

	MOVLW	0
	CALL	I2CStart	;X^[gRfBV
	;
	RLF		tmp2, F		;I2CX[uAhX
	BCF		tmp2, 0		;R/W=0(W)
	MOVFW	tmp2		;CB(W)
	CALL	I2CWrite	;CBM
	CALL	Delay
	;
	MOVFW	tmp1		;Mf[^
	CALL	I2CWrite	;f[^M(1st)
	CALL	Delay
	;
	COMF	tmp1, W		;1oCgڂ̃f[^rbg]
	CALL	I2CWrite	;f[^M(2nd)
	;
	CALL	I2CStop		;XgbvRfBV
	;
	GOTO	next1

j_btn2:					;Btn2̏ I2C}X^M
	CALL	GetSWAdrs	;MX[uEAhXXibvSW擾
	BANKSEL	tmp2
	MOVWF	tmp2		;AhX
	;
	MOVLW	0
	CALL	I2CStart	;X^[gRfBV
	;
	BANKSEL	tmp2
	RLF		tmp2, F		;I2CX[uEAhX
	BSF		tmp2, 0		;R/W=1
	MOVFW	tmp2		;CB(R)
	CALL	I2CWrite	;CBM

	CALL	Delay

	MOVLW	0			;ACK
	CALL	I2CRead	;1oCgM(1st)
	CALL	LCDPrint2Hexa	;LCD1oCgڂ\

	CALL	Delay

	MOVLW	1			;NOACK
	CALL	I2CRead		;1oCgM(2nd)
	CALL	LCDPrint2Hexa	;LCD1oCgڂ\

	CALL	Delay

	CALL	I2CStop		;XgbvRfBV
	GOTO	next1

j_btn3:					;Btn3̏
	GOTO	next1


next1:
	GOTO	MainLoop


Delay:
	CALL	Delay1ms
	GOTO	Delay1ms


INTERRUPT:
	RETFIE

	END
