;
; }CR1 2 3C^[tF[Xp 11
;	copyright(c) T.Nakao 2007
;
; SPIn[hEFA}X^EAvP[V
;	hCo eXg
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\Common\ComDef.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\AppFnc.inc>
	INCLUDE <..\\common\\Delay.inc>
	INCLUDE <..\\common\\SPIHMS.inc>	;SPIn[hEFAhCo

	__CONFIG 0x3F72

	GLOBAL arg1, arg2

	radix	dec

	UDATA
arg1    RES 1
arg2    RES 1
key		RES 1

tmp1	RES	1


RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

START:
;	CALL	copy_init_data

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0		;LED1
	BCF		TRISC, 1		;LED2

	CALL	LCDInit			;LCD
	CALL	InitBtn			;{^

	CALL	SPIMsInit		;SPI}X^

	LED1_OFF
	LED2_OFF


MainLoop:
	CALL	ScanBtn			;{^̓XL
	;
	CALL	GetBtn
	IORLW	0
	BZ		MainLoop		;͂ȂƂ
	BANKSEL	key
	MOVWF	key				;̓R[hۑ
	DECF	key
	BZ		j_btn1
	DECF	key
	BZ		j_btn2
	DECF	key
	BZ		j_btn3
	;
	; j_btn4				;Btn4̏ LCDNA
	CALL	LCDClear		;LCDNAs
	LED1_OFF
	LED2_OFF
	GOTO	MainLoop

j_btn1:						;Btn1̏ SPI}X^M
	CALL	GetSWData		;gOXCb`f[^I
	MOVWF	SPITxData		;}X^Mf[^

	CALL	SPIMsCom		;}X^M

	MOVFW	SPIRxData		;}X^Mf[^
	CALL	LCDPrint2Hexa	;LCD֎Mf[^\
	GOTO	MainLoop

j_btn2:						;Btn2̏
j_btn3:						;Btn3̏
	GOTO	MainLoop


INTERRUPT:
	RETFIE

	END
