;
; }CR1 2 3C^[tF[Xp 13
;	copyright(c) T.Nakao 2007
;
; One-Wire vWFNg2
;	1-Wirevg^CvEhCo eXgpAvP[V
;		ROMR[hǂݏo,CRCvZ
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>

	__CONFIG 0x3F72

	GLOBAL arg1, arg2

	EXTERN OneWireInit, OWBusReset, OWWriteByte, OWReadByte
	EXTERN OWCrc, CrcBuf

	radix	dec

	UDATA
; local
arg1    RES 1
arg2    RES 1
owdata	RES 8
cnt		RES 1
ptr		RES	1
ptr2	RES	1


RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

INTERRUPT:
	RETFIE

START:
;	CALL	copy_init_data

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0		;LED1
	BCF		TRISC, 1		;LED2

	LED1_OFF
	LED2_OFF
	CALL	LCDInit			;LCD

	CALL	OneWireInit		;1-wire 

	;-------------------------------------
	; oXEZbg
	;-------------------------------------
	CALL	OWBusReset
	IORLW	0
	BZ		j1			;v[XpX񌟏o
	LED1_ON				;v[XpXo
	;
	;-------------------------------------
	; READ ROM R}h
	;-------------------------------------
j1:
	MOVLW	0x33
	CALL	OWWriteByte

	;-------------------------------------
	; ROMR[h̓ǂݏo(8byte)
	;-------------------------------------
	MOVLW	8
	BANKSEL	cnt
	MOVWF	cnt

	MOVLW	owdata
	MOVWF	FSR			;|C^ݒ
lp:
	CALL	OWReadByte
	MOVWF	INDF
	INCF	FSR, F

	BANKSEL	cnt
	DECFSZ	cnt, F
	GOTO lp
	;
	;-------------------------------------
	;ǂݏoROMR[hLCD֕\
	;-------------------------------------
	; LCD 1ڂɍŏ4oCg
	MOVLW	4
	BANKSEL	cnt
	MOVWF	cnt
	MOVLW	owdata		;AhX
	MOVWF	ptr			;|C^ݒ
	;
lp2:
	BANKSEL	ptr
	MOVFW	ptr
	MOVWF	FSR
	INCF	ptr, F
	MOVFW	INDF
	CALL	LCDPrint2Hexa
	;
	MOVLW	','
	CALL	LCDPutc
	;
	BANKSEL	cnt
	DECFSZ	cnt, F
	GOTO lp2
	;
	; LCD 2ڂɎc4oCg
	MOVLW	4
	BANKSEL	cnt
	MOVWF	cnt

	MOVLW	0
	MOVWF	CurX
	MOVLW	1
	MOVWF	CurY
	CALL	LCDGotoXY
lp3:
	BANKSEL	ptr
	MOVFW	ptr
	MOVWF	FSR
	INCF	ptr, F
	MOVFW	INDF
	CALL	LCDPrint2Hexa
	MOVLW	','
	CALL	LCDPutc

	BANKSEL	cnt
	DECFSZ	cnt, F
	GOTO lp3

	;-------------------------------------
	; CRC
	;-------------------------------------
	; ROMR[hCRCvZpobt@(CrcBuf)ɃRs[
	MOVLW	8
	BANKSEL	cnt
	MOVWF	cnt
	MOVLW	owdata		;\[XEAhX
	MOVWF	ptr			;|C^ݒ
	;
	MOVLW	CrcBuf		;fBXeBl[VEAhX
	MOVWF	ptr2		;|C^ݒ
lp4:
	MOVFW	ptr
	MOVWF	FSR
	MOVFW	INDF		;1oCgo
	MOVWF	owdata
	INCF	ptr, F
	;
	MOVFW	ptr2
	MOVWF	FSR
	MOVFW	owdata
	MOVWF	INDF		;1oCgۑ
	INCF	ptr2, F
	;
	DECFSZ	cnt
	GOTO	lp4

	; CRCvZ
	CALL	OWCrc			;CRCvZW
	CALL	LCDPrint2Hexa	;ʕ\

	GOTO $

	END
