;
; }CR1 2 3C^[tF[Xp 13
;	copyright(c) T.Nakao 2007
;
; One-Wire vWFNg6
;	1-WireŏIŃhCo eXgpAvP[V
;		ROMR[h, ̉xZT̉xǂݏo
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>
	INCLUDE <..\\common\\Hexa.inc>
	INCLUDE <..\\common\\Lcd.inc>
	INCLUDE <..\\common\\Key.inc>
	INCLUDE <..\\common\\Delay.inc>
	INCLUDE <..\\Common\\OW.inc>
	INCLUDE <..\\Common\\OW.inc>

	__CONFIG 0x3F72

	GLOBAL arg1, arg2

	radix	dec

	UDATA
; local
arg1    RES 1
arg2    RES 1
cnt		RES 1
ptr		RES	1
ptr2	RES	1
srsts	RES	1
cnt2	RES 1
cnt3	RES 1

devcnt	RES	1
offset	RES	1
iobyte	RES	1
index	RES	1
owdata	RES 9

temp1	RES	1		;x
temp2	RES	1
subtotal	RES	1
tmpptr	RES	1
ledsts	RES	1


ROMCD	UDATA
RomCodeAr	RES 32			;ROMR[hۑGA 8byte X4


RESET CODE 0
	GOTO	START
	NOP
	NOP
	GOTO	INTERRUPT

	CODE

INTERRUPT:
	RETFIE

START:
;	CALL	copy_init_data

MAIN:
	BANKSEL	TRISC
	BCF		TRISC, 0		;LED1
	BCF		TRISC, 1		;LED2

	LED1_OFF
	LED2_OFF

	CALL	LCDInit

	CALL	OWInit			;1wire init

	BANKSEL	devcnt
	CLRF	devcnt			;ofoCX

	;-------------------------------------------------
	; ROM
	;-------------------------------------------------
	;
	CALL	OWRomSearch		;ROM()
	BANKSEL	srsts
	MOVWF	srsts			;sʂۑ
	;
lpp2:
	;
	;-------------------------------------
	; CRC
	;-------------------------------------
	MOVLW	RomCode
	MOVWF	CrcBufPtr		;060910
	MOVLW	8				;CRCvZΏۂ̃oCg
	MOVWF	CrcCnt
	;
	CALL	OWCrc			;CRCvZW
	IORLW	0
	BNZ		j_next			;CRC error

	BANKSEL	devcnt
	INCF	devcnt, F

	;-----------------------------------------------------
	; ROMR[hۑGA֓ǂݏoROMR[hRs[
	;-----------------------------------------------------
	DECF	devcnt, W		;foCX-1
	IORLW	0
	BZ		jj2				;ItZbg=0
	;
	MOVWF	cnt				;[vJEg(foCX-1)
	MOVLW	8				;ItZbgZl(ROMR[hGÃoCg)
	CLRF	offset
lp1:
	ADDWF	offset, F		;+8
	DECFSZ	cnt
	GOTO	lp1
	;
jj2:
	BANKSEL	RomCodeAr
	MOVLW	RomCodeAr		;W=AhX
	;
	BANKSEL	offset
	ADDWF	offset, W		;ItZbgZ
	MOVWF	ptr				;ptr=x[XAhXɃItZbgl
	;						;  (fBXeBl[VAhX)
	MOVLW	RomCode
	MOVWF	ptr2			;ptr2(\[XAhX)
	;
	MOVLW	8
	MOVWF	cnt				;[vJEg
	;
lp2:
	BANKISEL	RomCode
	MOVFW	ptr2			;\[X
	MOVWF	FSR
	MOVFW	INDF			;ǂݏo
	MOVWF	iobyte			;ۑ
	INCF	ptr2, F			;̃AhX
	;
	BANKISEL	RomCodeAr
	MOVFW	ptr				;fBXeBl[V
	MOVWF	FSR
	MOVFW	iobyte			;A
	MOVWF	INDF			;
	INCF	ptr, F			;̃AhX
	;
	DECFSZ	cnt
	GOTO	lp2				;8oCgJԂ
	;
	;
j_next:
	;-------------------------------------
	; ̌̏
	;-------------------------------------
	BANKSEL	srsts
	MOVFW	srsts			;̎s
	SUBLW	2				;̎c`FbN
	BZ		lpp				;̃foCX̌
	;
;	LED2_ON					;$$$
	GOTO Init2				;̏

lpp:
	CALL	LCDClear
;	LED1_ON					;$$$

	CALL	OWReSearch		;ROM(2ڈȍ~)
	BANKSEL	srsts
	MOVWF	srsts			;sʂۑ
	GOTO	lpp2


;*************************************************
; 2
;*************************************************
Init2:
	BANKSEL	ledsts
	CLRF	ledsts
	;
	;
;*************************************************
; C[v
;*************************************************
MainLoop:
	;
	BANKSEL	tmpptr
	CLRF	tmpptr
	MOVFW	devcnt			;ofoCX
	MOVWF	cnt3			;[vJE^

	;-------------------------------------
	; oXZbg
	;-------------------------------------
	CALL	OWBusReset

	;-------------------------------------
	; SKIP ROM R}h
	;-------------------------------------
	MOVLW	0xCC			;SKIP ROM command
	CALL	OWWriteByte		;R}hM

	;-------------------------------------
	; CONVERT T R}h
	;-------------------------------------
	MOVLW	0x44			;CONVERT T command
	CALL	OWWriteByte		;R}hM(ׂĂDS18S20)

	;750ms ȏ̃fBC
	BANKSEL	cnt2
	MOVLW	150
	MOVWF	cnt2
lp33:
	CALL	Delay5ms
	DECFSZ	cnt2
	GOTO	lp33

	;-------------------------------------
	;xǂݏoA\
	;-------------------------------------
mlp:

	BANKSEL	tmpptr
	MOVFW	tmpptr
	MOVWF	temp1
	DECF	temp1, F
	BZ		j_d1				;ZT1
	DECF	temp1, F
	BZ		j_d2				;ZT2
	DECF	temp1, F
	BZ		j_d3				;ZT3
	;
	; tmpptr==0 ZT0
	;
	LDLF	0, CurX
	LDLF	0, CurY
j_com:
	CALL	LCDGotoXY
	BANKSEL	tmpptr
	MOVFW	tmpptr
	CALL	LCDPrint2Hexa		;CfbNXԍ\("00"-"03")
	MOVLW	':'
	CALL	LCDPutc
	;
	BANKSEL	tmpptr
	MOVFW	tmpptr				;xZTI
	CALL	GetTemperature		;xǂݏoĕ\

	BANKSEL	tmpptr
	INCF	tmpptr, W			;̉xZT̃CfbNX

	ANDLW	0x03				;2rbg(bvEAEh)
	MOVWF	tmpptr
	DECFSZ	cnt3, F
	GOTO	mlp					;4\
	;
	; LED_
	;
	INCF	ledsts, F
	MOVFW	ledsts
	ANDLW	1
	BZ		j_off
	LED1_ON
	GOTO	MainLoop
	;
j_off:
	LED1_OFF
	;
	GOTO	MainLoop


j_d1:
	LDLF	8, CurX
	LDLF	0, CurY
	GOTO	j_com

j_d2:
	LDLF	0, CurX
	LDLF	1, CurY
	GOTO	j_com

j_d3:
	LDLF	8, CurX
	LDLF	1, CurY
	GOTO	j_com


;*************************************************
;  ROMR[hM
;    : W:ǂݍROMR[h̃CfbNX(0`3)
;*************************************************

TxRomCode:
	BANKSEL	index
	MOVWF	index			;ZTCfbNX(0-3)
	;
	CLRF	offset
	;
	IORLW	0				;index==0 ?
	BZ		jj21			;ItZbg=0
	;
	MOVWF	cnt				;[vJEg(foCX-1)
	MOVLW	8				;ItZbgl
lp11:
	ADDWF	offset, F		;+8
	DECFSZ	cnt
	GOTO	lp11
	;
jj21:
	BANKSEL	RomCodeAr
	MOVLW	RomCodeAr		;W=AhX
	BANKSEL	offset
	ADDWF	offset, W		;ItZbgZ
	MOVWF	ptr				;ptr=x[XAhXɃItZbgl
	;						;  (\[XAhX)
	MOVLW	8
	MOVWF	cnt				;[vJEg
	;
lp21:
	BANKISEL	RomCodeAr
	MOVFW	ptr				;\[X
	MOVWF	FSR
	MOVFW	INDF			;ǂݏo W<-f[^
	INCF	ptr, F			;̃AhX
	;
	CALL	OWWriteByte		;ROMR[hM
	;
	DECFSZ	cnt
	GOTO	lp21			;8oCgJԂ
	;
	RETURN


;*************************************************
;  x\
;    : W;x(DS18S20 A/Dl)
;*************************************************
PrintTemperature:
	MOVWF	temp1
	CLRC
	RRF		temp1, W		;X0.5 (1/2)
	MOVWF	temp1			;Z̉x(ȉ؂̂)
	MOVWF	temp2
	;
	;-------------------------------------
	;W̒l10iLCDɕ\
	;-------------------------------------
	CLRF	cnt				;Z̉
	CLRF	subtotal		;l̍v
	MOVLW	10
j_sublp:
	SUBWF	temp1, F		;temp1-10
	BNC		j_borrow		;(CY==0)ȂƂ
	INCF	cnt, F			;+1
	ADDWF	subtotal, F		;subtotal+10
	GOTO	j_sublp			;ȂȂ܂ŌJԂ

j_borrow:
	MOVFW	cnt
	MOVWF	temp1			;temp1=10̌̉xl
	MOVFW	subtotal
	SUBWF	temp2, F		;temp2=temp2-subtotal(10Ŋ܂)
	;						;  1̌̉xl

	SWAPF	temp1, W		;4rbg4rbgɈړ(10̌)
	ADDWF	temp2, W		;1̌̒lZ W=temp2+W
	;						;  [I16i

	CALL	LCDPrint2Hexa	; 2\
	;
	MOVLW	'.'				;_
	CALL	LCDPutc

	;-------------------------------------
	;_ȉ̕\
	;-------------------------------------
	BANKSEL	owdata
	CLRC
	RRF		owdata, W		;X0.5 (1/2)
	BC		jj22			;]肠(+0.5)
	;
	;]Ȃ(+0.0)
	MOVLW	'0'				;_ȉ̒l
	GOTO	jj23

jj22:
	;]肠(+0.5)
	MOVLW	'5'				;_ȉ̒l
jj23:
	CALL	LCDPutc
	RETURN


;*************************************************
;  x(XNb`pbh)ǂݏoALCD\
;    : W;DS18S20CfbNX(0-3)
;*************************************************
GetTemperature:
	BANKSEL	temp1
	MOVWF	temp1			;CfbNXꎞۑ

	;-------------------------------------
	; oXZbg
	;-------------------------------------
	CALL	OWBusReset

	;-------------------------------------
	; MATCH ROMR}h(1̃foCXI)
	;-------------------------------------
	; }b`ROMR}hM
	MOVLW	0x55			;MATCH ROM command
	CALL	OWWriteByte		;R}hM
	;
	; ROMR[hM
	MOVFW	temp1			;W=CfbNX(0-3)
	CALL	TxRomCode		;64rbgM

	;-------------------------------------
	; [hXNb`pbhR}h
	;-------------------------------------
	MOVLW	0xBE			;READ SCRATCHPAD command
	CALL	OWWriteByte		;R}hM
	;
	; XNb`pbhǂݏo
	BANKSEL	cnt
	MOVLW	9				;XNb`pbh̃oCg
	MOVWF	cnt
	;
	BANKISEL	owdata
	MOVLW	owdata			;Mf[^i[̐擪AhX
	MOVWF	ptr				;|C^ݒ
	;
lp41:
	MOVFW	ptr
	MOVWF	FSR
	INCF	ptr, F			;̃AhX(̏)
	CALL	OWReadByte		;ǂݏo
	MOVWF	INDF			;ۑ
	;
	DECFSZ	cnt
	GOTO	lp41			;9oCgJԂ
	;
	;
	;owdata[9]ɃXNb`pbh̓eĂ
	;
	MOVFW	owdata			;xlo W=owdata[0]
	CALL	PrintTemperature	;LCD։x\ xx.x

	RETURN



	END
