;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
;	HEXA[eBeBE[`
;

	LIST	p=16f877a
	INCLUDE	<p16F877a.inc>
	INCLUDE	<ComDef.inc>
	INCLUDE	<Lcd.inc>

	EXTERN	arg1, arg2

	GLOBAL	Get1Hex, Get2Hex, StrBuf, LCDPrint2Hexa, LCDPrint4Hexa

	radix	dec

	UDATA
temp1	RES 1
temp2	RES 1
StrBuf	RES 5		;ő4+NULL

	CODE

;************************************************
; 4rbg16i1HEXAɕϊ
;     W (0-15)
;    ϊ W ('0'-'9','A'-'F')
;************************************************
Get1Hex:
	BANKSEL	temp1
	MOVWF	temp1
	SUBLW	9
	BC		jj1
	; A-F
	MOVLW	'A'-.10		;"A"
	ADDWF	temp1, W
	RETURN
jj1:
	; 0-9
	MOVLW	'0'
	ADDWF	temp1, W
	RETURN


;************************************************
; 1oCg16i2HEXAɕϊ
;     W (0-0xFF)
;    ϊ StrBuf[3] NULL܂
;************************************************
Get2Hex:
	BANKSEL	temp2
	MOVWF	temp2

	BANKSEL	StrBuf
	BANKISEL	StrBuf	;
	MOVLW	StrBuf		;obt@
	MOVWF	FSR

	BANKSEL	temp2
	SWAPF	temp2, W
	ANDLW	0x0F
	CALL	Get1Hex		;result->W
	MOVWF	INDF		;16iʕۑ
	INCF	FSR
	;
	BANKSEL	temp2
	MOVF	temp2, W
	ANDLW	0x0F
	CALL	Get1Hex
	MOVWF	INDF		;16iʕۑ
	INCF	FSR
	;
	CLRW
	MOVWF	INDF		;NULLۑ

	RETURN


;************************************************
; 16i4LCD֕\
;    arg1(8bit), arg2(8bit)
;************************************************
LCDPrint4Hexa:
	BANKSEL	arg2
	MOVF	arg2, W
	CALL	LCDPrint2Hexa	;2\

	BANKSEL	arg1
	MOVF	arg1, W
	; LCDPrint2Hexa֑(2\)
	;
;************************************************
; 16i2LCD֕\
;    W
;************************************************
LCDPrint2Hexa:
	CALL	Get2Hex

	BANKSEL	StrBuf
	BANKISEL	StrBuf
	MOVLW	StrBuf
	MOVWF	FSR
	;
	GOTO	LCDString


	END
