;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
; I2C\tgEFAX[uEhCo
;

	LIST	 p=16f877a
	INCLUDE <p16F877a.inc>
	INCLUDE <..\\Common\\ComDef.inc>

	GLOBAL	I2CSlInit, I2CCheckEdge, I2CSlCom
	GLOBAL	I2CSts, I2CSts2, MyAdrs, I2CTxData, I2CRxData, CByte

	EXTERN	SlaveInit, SlaveReceive, SlaveSend		;061014

	radix	dec

bitSDA	EQU 4
bitSCL	EQU 3


; I2CStsrbgϐ(rbgԍ)
BefSCL	EQU 0	;OSCL̏
BefSDA	EQU 1	;OSDȀ
SCLUp	EQU 2	;SCLオGbWo
SCLDown	EQU 3	;SCLGbWo
SCond	EQU 4	;X^[gRfBVo
PCond	EQU 5	;XgbvRfBVo

; I2CSts2rbgϐ(rbgԍ)
AdrsFlg	EQU 0	;AhXEtO X[uCBM
RxFlg	EQU 1	;MtO X[uf[^M
TxFlg	EQU 2	;MtO X[uf[^M
AckOut	EQU 3	;ACKo͒tO ACKo͋
AckFlg	EQU 4	;ACKtO ACKM
Ack		EQU	5	;ACK 0:ACK/1:NOACK
Ack2	EQU	6	;ACK 0:ACK/1:NOACK


	UDATA

I2CSts	RES	1		;rbgϐ
I2CSts2	RES	1		;rbgϐ
SlvAdrs	RES 1		;I2CX[uAhX(b7b17rbg)
LopCnt	RES 1		;[vJE^
CByte	RES	1		;MRg[oCgpobt@(AhX+R/W)
MyAdrs	RES 1		;AhX(l7rbg,b0=0)

I2CTxData	RES	1
I2CRxData	RES	1
I2CRxBuf	RES	1

	;-------------------------------------------------

; 061014
SCL_H	MACRO
	BANKSEL	TRISC
	BSF		TRISC, bitSCL		;input Hi-Z="H"
	ENDM

SCL_L	MACRO
	BANKSEL	PORTC
	BCF		PORTC, bitSCL
	BANKSEL	TRISC
	BCF		TRISC, bitSCL		;output "L"
	ENDM

SDA_H	MACRO
	BANKSEL	TRISC
	BSF		TRISC, bitSDA		;input Hi-Z="H"
	ENDM

SDA_L	MACRO
	BANKSEL	PORTC
	BCF		PORTC, bitSDA
	BANKSEL	TRISC
	BCF		TRISC, bitSDA		;output "L"
	ENDM


;****************************************
; I2CX[u(\tgEFA쓮) 7bit mode
;    W X[uAhX
;****************************************
	CODE

I2CSlInit:
	BANKSEL	MyAdrs
	MOVWF	MyAdrs
	CLRC
	RLF		MyAdrs, F			;I2CX[uAhX(ʋl)

	BANKSEL	TRISC
	BSF		TRISC, bitSDA		;SDA input
	BSF		TRISC, bitSCL		;SCL input

	BANKSEL	I2CSts
	CLRF	I2CSts
	CLRF	I2CSts2

	BSF		I2CSts, BefSCL
	BSF		I2CSts, BefSDA

	BCF		I2CSts2, AdrsFlg
	BCF		I2CSts2, RxFlg
	BCF		I2CSts2, TxFlg
	BCF		I2CSts2, Ack2		;f[^MAckf[^(ACK="L")

	RETURN


;****************************************
; SCLMGbWo, X^[g/XgbvRfBVo
;   SCL,SDÃNbNEGbW`FbN
;   (bit) true"1"
;     I2CSts.SCLUp
;     I2CSts.SCLDown
;     I2CSts.PCond
;     I2CSts.SCond
;****************************************
I2CCheckEdge:
	BANKSEL	I2CSts2
	BTFSC	I2CSts2, TxFlg
	GOTO	nx1

	;-------------------------------------------------
	; SDÃGbW`FbN
	;-------------------------------------------------
	BANKSEL PORTC
	BTFSC	PORTC, bitSDA
	GOTO	j_SDA_H			;SDA==H
	;
	;SDA==L
	BANKSEL	I2CSts
	BTFSC	I2CSts, BefSDA
	GOTO	j_sdafall		;SDA H->L GbWo
	; next LŕωȂ
	GOTO	nx1

j_SDA_H:
	;SDA==H
	BANKSEL	I2CSts
	BTFSS	I2CSts, BefSDA
	GOTO	j_sdarize		;SDA L->H オGbWo
	; next HŕωȂ
	GOTO	nx1

	;SDAGbWo
j_sdafall:
	BANKSEL	I2CSts
	BCF		I2CSts, BefSDA	;񌟏ô,݂̏(Lx)ۑ

	BANKSEL	PORTC
	BTFSS	PORTC, bitSCL
	GOTO	nx1		;not
	;
	;X^[gRfBVo
	BANKSEL	I2CSts
	BSF		I2CSts, SCond
	BCF		I2CSts, SCLUp
	BCF		I2CSts, SCLDown
	BCF		I2CSts2, AckOut
	BCF		I2CSts2, AckFlg
	RETURN

	;SDAオGbWo
j_sdarize:
	BANKSEL	I2CSts
	BSF		I2CSts, BefSDA	;񌟏ô,݂̏(Hx)ۑ

	BANKSEL	PORTC
	BTFSS	PORTC, bitSCL
	GOTO	nx1		;not
	;
	;XgbvRfBVo
	BANKSEL	I2CSts
	BSF		I2CSts, PCond
	BCF		I2CSts, SCLUp
	BCF		I2CSts, SCLDown
	RETURN

nx1:
	;
	;-------------------------------------------------
	; SCL̃GbW`FbN
	;-------------------------------------------------
	BANKSEL PORTC
	BTFSC	PORTC, bitSCL
	GOTO	j_SCL_H			;SCL==H
	;
	;SCL==L
	BANKSEL	I2CSts
	BTFSC	I2CSts, BefSCL
	GOTO	j_befSCL_H		;SCLGbWo
	; next LŕωȂ
	GOTO	nx2

j_SCL_H:
	;SCL==H
	BANKSEL	I2CSts
	BTFSS	I2CSts, BefSCL
	GOTO	j_befSCL_L		;SCLオGbWo
	; next HŕωȂ
	GOTO	nx2

	;SCLGbWo
j_befSCL_H:
	BSF		I2CSts, SCLDown
	BCF		I2CSts, BefSCL	;񌟏ô,݂̏(Lx)ۑ
	GOTO	nx2

	;SCLオGbWo
j_befSCL_L:
	BSF		I2CSts, SCLUp
	BSF		I2CSts, BefSCL	;񌟏ô,݂̏(Hx)ۑ
nx2:
	RETURN


;****************************************
;  hCoEC
;    CE[vR[
;****************************************
I2CSlCom:
	;
	CALL	I2CCheckEdge		;SCL/SDA̗オ/GbW`FbN

	BANKSEL	I2CSts
	BTFSC	I2CSts, SCond
	GOTO	j_scond				;X^[gRfBVo
	;
	BTFSC	I2CSts, PCond
	GOTO	j_pcond				;XgbvRfBVo
	;
	BTFSC	I2CSts2, RxFlg
	GOTO	RxProc				;CB,f[^M
	;
	BTFSC	I2CSts2, TxFlg
	GOTO	TxProc				;f[^M
	RETLW	0

	;X^[gRfBVo
j_scond:
	BANKSEL	I2CSts
	BCF		I2CSts, SCond
	BSF		I2CSts2, RxFlg
	BCF		I2CSts2, TxFlg
	BSF		I2CSts2, AdrsFlg
	MOVLW	8
	MOVWF	LopCnt			;[vJE^
	RETLW	0

	;XgbvRfBVo
j_pcond:
	BANKSEL	I2CSts
	BCF		I2CSts, PCond
	BCF		I2CSts2, AdrsFlg
	BCF		I2CSts2, RxFlg
	BCF		I2CSts2, TxFlg
	RETLW	0

	;-------------------------------------------------
	; M
	;-------------------------------------------------
RxProc:
	BTFSC	I2CSts2, AckFlg
	GOTO	j_ackout		;[ACKo͏]
	;
	BTFSS	I2CSts, SCLUp
	RETLW	0				;false
	;
	; [f[^rbg͏]

	LED1_ON			;$$$
	BANKSEL	I2CSts	;$$$

	BCF		I2CSts, SCLUp

	BANKSEL	PORTC
	BTFSC	PORTC, bitSDA
	GOTO	j_sda_h
	;
	;SDA==L
	CLRC
	RLF		I2CRxBuf, F
	GOTO	nx001

	; SDA==H
j_sda_h:
	SETC
	RLF		I2CRxBuf, F
	;
nx001:
	LED1_OFF;				;$$$
	BANKSEL	I2CSts2			;$$$

	DECFSZ	LopCnt, F
	RETLW	0				;false
	;
	; 8rbg͏I
	;
	BCF		I2CSts, SCLDown	;061004

	BTFSC	I2CSts2, AdrsFlg
	GOTO	j_cbyte			;[I2CX[uAhX]
	;
	; [ʏf[^M]
	;
	BTFSC	I2CSts2, Ack2	;Ack2̓eAckɃRs[
	GOTO	j_ack_h
	;
	BCF		I2CSts2, Ack	;Ack=0
	GOTO	nx004
	;
j_ack_h:
	BSF		I2CSts2, Ack	;Ack=1
	;
nx004:
	MOVFW	I2CRxBuf
	MOVWF	I2CRxData		;Mf[^ۑ
	BSF		I2CSts2, AckFlg
	RETLW	0				;false

	;
	; [CBM]
	;
j_cbyte:
	MOVFW	I2CRxBuf
	MOVWF	CByte				;Rg[oCgۑ
	ANDLW	0xFE				;b0}XN
	SUBWF	MyAdrs, W			;AhXr
	BTFSS	STATUS, Z
	GOTO	j_idle				;AChɖ߂
	;
	; AhXv
	BSF		I2CSts2, AckFlg
	BCF		I2CSts2, Ack		;ACK(0)
	RETLW	0

j_idle:
	BCF		I2CSts2, RxFlg
	RETLW	0

	;
	; [ACKo͏]
	;
j_ackout:
	BANKSEL	I2CSts
	BTFSS	I2CSts, SCLDown
	RETLW	0				;
	;
	;茟o
	BCF		I2CSts, SCLDown
	BTFSC	I2CSts2, AckOut
	GOTO	j_ackout_end	;[ACKo͏I]
	;
	; [ACKo͊Jn]
	;
	LED2_ON;				;$$$
	BANKSEL	I2CSts2			;$$$

	BTFSC	I2CSts2, Ack
	GOTO	j_noack
	;
	SDA_L						;SDA="L"("0")
	GOTO	nx002

j_noack:
	SDA_H						;SDA="H"("1")
	;
nx002:
	BANKSEL	I2CSts2
	BSF		I2CSts2, AckOut		;ACKo͒tO=ON
	RETLW	0					;false

	;
	;[ACKo͏I]
	;
j_ackout_end:

	LED2_OFF;					;$$$
	BANKSEL	I2CSts2				;$$$

	BTFSS	I2CSts2, AdrsFlg
	GOTO	j_rcvnorm			;ʏf[^̂Ƃ
	;
	;CB̂Ƃ
	MOVFW	CByte
	CALL	SlaveInit			;CxgEnh 061015
	GOTO	j_11

j_rcvnorm:
	;ʏf[^̂Ƃ
	MOVFW	I2CRxData
	CALL	SlaveReceive		;CxgEnh(W:Mf[^)

j_11:
	BANKSEL	CByte
	BTFSS	CByte, 0			;R/Wrbg
	GOTO	j_rxdata			;R/Wrbg==0 M
	;
	; ****** M (R/W==1) ******
	BSF		I2CSts2, TxFlg		;MtO=ON
	BCF		I2CSts2, RxFlg		;MtO=OFF 061004

	CALL	SlaveSend			;CxgEnh Mf[^̏ 061014
	MOVWF	I2CTxData			;Mf[^ݒ

	;---------------------------------------
	; f[^̑rbgo(CBM)
	;---------------------------------------
	BANKSEL	I2CTxData
	RLF		I2CTxData, F		;b7o
	BNC		j_out_0				;"0"
	;
	; "1"
	SDA_H						;SDA="H"(b7="1")
	GOTO	nx003
	;
j_out_0:
	; "0"
	SDA_L						;SDA="L"(b7="0")
	GOTO	nx003

	; ****** M (R/W==0) ******
j_rxdata:
	BSF		I2CSts2, RxFlg
	BANKSEL	TRISC
	BSF		TRISC, bitSDA		;SDA|[g͂ɐݒ

nx003:
	BANKSEL	I2CSts2
	BCF		I2CSts2, AckFlg
	BCF		I2CSts2, AckOut
	BCF		I2CSts,	SCLUp		;061004
	MOVLW	8
	MOVWF	LopCnt				;[vJE^
	;
	;(NbNXgb`ꍇ̏͂)
	;
	BTFSC	I2CSts2, AdrsFlg
	GOTO	j_3					;AhXtOON(CB)̂Ƃ
	;
	BCF		I2CSts2, AdrsFlg	;AhXtO=OFF
	RETLW	2					;W:f[^M(2)

j_3:
	BCF		I2CSts2, AdrsFlg	;AhXtO=OFF
	RETLW	1					;W:CBM(1)



	;-------------------------------------------------
	; M
	;-------------------------------------------------

TxProc:
	BTFSC	I2CSts2, AckFlg
	GOTO	j_ackin		;[ACK͏]
	;
	BTFSS	I2CSts, SCLDown
	RETLW	0				;false

	BCF		I2CSts, SCLDown
	DECF	LopCnt, F
	BZ		j_ackin_s		;[ACK͂̊Jn]

	LED1_ON					;$$$
	BANKSEL	I2CTxData		;
	RLF		I2CTxData, F	;b6珇ԂMSBo
	BNC		j_out_0_2		;"0"
	;
	; "1"
	SDA_H					;SDA="H"("1")
	LED1_OFF				;$$$
	RETLW	0				;false

j_out_0_2:
	; "0"
	SDA_L					;SDA="L"("0")
	LED1_OFF				;$$$
	RETLW	0

	;[ACK͂̊Jn]
j_ackin_s:
	BSF		I2CSts2, AckFlg	;ACKtO=ON
	BANKSEL	TRISC
	BSF		TRISC, bitSDA	;SDA|[g͂ɐݒ
	LED2_ON					;$$$
	RETLW	0


	;[ACK͏]
j_ackin:
	BTFSS	I2CSts, SCLUp	;SCL̗オ
	GOTO	j_2
	;
	; [SCL(ACK)̗オGbW]
	;
	BCF		I2CSts, SCLUp
	LED1_ON					;$$$
	BANKSEL	PORTC
	BTFSC	PORTC, bitSDA
	GOTO	j_rcv_noack
	;
	; ACKM
	;
	LED1_OFF				;$$$
	; ToDo: 
	;
	RETLW	0

	; NOACKM
j_rcv_noack:
	;
	LED1_OFF				;$$$
	; ToDo: NoACK
	;
	RETLW	0


j_2:
	BTFSS	I2CSts, SCLDown	;SCL̗
	RETLW	0
	;
	BCF		I2CSts, SCLDown
	;
	; [SCL(ACK)̗GbW]
	;
	; [ACK͂̏I]
	;
	LED2_OFF					;$$$
	BANKSEL	I2CSts2

	BCF		I2CSts, SCLUp		;061005
	BCF		I2CSts2, AckFlg
	BANKSEL	PORTC
	BTFSC	PORTC, bitSDA		;ACKǂݍ
	GOTO	j_noack2
	;
	; ACKM
	;
	; (NbNXgb`̏ꍇ͂)
	;
	; [̃f[^o͏֌p]
	;
	CALL	SlaveSend			;CxgEnh ̃f[^̏ 061014

	;----------------------------------------------------
	; ̑Mf[^̑rbgo(f[^M)
	;----------------------------------------------------
	BANKSEL	I2CTxData
	MOVWF	I2CTxData
	RLF		I2CTxData, F		;b7o
	BNC		j_out_3				;"0"
	;
	; "1"
	SDA_H						;SDA="H"(b7="1")
	GOTO	nx0033

j_out_3:	; "0"
	SDA_L						;SDA="L"(b7="0")
	;
nx0033:
	BANKSEL	LopCnt
	MOVLW	8
	MOVWF	LopCnt				;[vJE^
	RETLW	3					;M(ACK)

	; NOACKM
	;
j_noack2:
	BANKSEL	I2CSts2
	BCF		I2CSts2, TxFlg		;MtO=OFF
	RETLW	4;					;M(NOACK)


	END
