;
; }CR1 2 3C^[tF[Xp
;	copyright(c) T.Nakao 2007
;
;	XCb`̓[`
;

; \[X
; ^NgXCb`:   RB4`RB7
; XibvXCb`: RB0`RB3
; TIMER0gp
;

	LIST	p=16f877a
	INCLUDE	<p16F877a.inc>
	INCLUDE	<ComDef.inc>

	GLOBAL	InitBtn, ScanBtn, GetBtn, BtnCode, GetSw

	radix	dec

; rbgATC
BTN1	EQU 4	;^NgXCb`
BTN2	EQU 5
BTN3	EQU 6
BTN4	EQU 7

SW1		EQU 0	;gOXCb`
SW2		EQU 1
SW3		EQU 2
SW4		EQU 3


; [Jϐ
	UDATA
BefBtn	RES 1	;b7:BTN1..b4:BTN4 0:push
CurBtn	RES 1
BtnSts	RES 1	;sv
FlagBit	RES 1	;b0:ǂ̃tO
BtnCnt	RES 1	;{^Ԃ̘Av
tmp1	RES 1
tmp2	RES 1
;
; O[oϐ
BtnCode	RES 1


	CODE

; *****************************************
; {^͏(TIMER0)̏
; *****************************************
InitBtn:
	BANKSEL	OPTION_REG

	; TIMER0
	BCF	OPTION_REG, NOT_RBPU	;RB pullup enable
	BCF	OPTION_REG, T0CS
	BCF	OPTION_REG, PSA
	BSF	OPTION_REG, PS2			; TMR0vXP[1/256
	BSF	OPTION_REG, PS1
	BSF	OPTION_REG, PS0

	BANKSEL	TRISB
	LDLF	0xFF, TRISB	;RB all input

	BANKSEL	BtnCnt
	CLRW
	MOVWF	BtnCnt
	MOVWF	BefBtn
	MOVWF	BtnCode
	MOVWF	FlagBit

	RETURN


; *****************************************
; {^ԂXL(C[vɓ)
;   ߒl {^R[h:BtnCode  0,1`4({^ԍ)
; *****************************************
ScanBtn:
	BANKSEL	INTCON
	BTFSS	INTCON, TMR0IF
	RETURN

	;TMR0I[ot[(XL^C~O)
	BCF	INTCON, TMR0IF

	BANKSEL	PORTB
	MOVF	PORTB, W
	ANDLW	0xF0
	BANKSEL	CurBtn
	MOVWF	CurBtn			;݂̃{^̏Ԃۑ

	MOVF	BefBtn, W		;Õ{^̏

	SUBWF	CurBtn, W		;ȌԂƔr
	BNZ		unmatch1		;Oƕsv̂Ƃ

	;OƈvĂƂ
	BANKSEL	BtnCnt
	INCF	BtnCnt			;v񐔂XV
	MOVLW	3				;vm n>=3
	SUBWF	BtnCnt, W		;f-w (BtnCnt-3)
	BTFSC	STATUS, C
	RETURN					;܂K񐔂ɒBĂȂƂ
	;
	;͂m肵Ƃ
	DECF	BtnCnt			;JEg̒~
	MOVLW	0xF0
	SUBWF	CurBtn, W
	BTFSC	STATUS, Z
	GOTO	rels1			;Ȃm̂Ƃ
	;
	;
	BTFSC	FlagBit, 0
	RETURN					;ɉ̂Ƃ͉Ȃ
	BSF		FlagBit, 0			;ɐݒ
	;
	;ꂽ{^(bit==0)𒲂ׂ

	BTFSS	CurBtn, BTN1
	GOTO	bt1
	BTFSS	CurBtn, BTN2
	GOTO	bt2
	BTFSS	CurBtn, BTN3
	GOTO	bt3
	;else
	LDLF	4, BtnCode			;{^4
	RETURN
bt1:
	LDLF	1, BtnCode			;{^1
	RETURN
bt2:
	LDLF	2, BtnCode			;{^2
	RETURN
bt3:
	LDLF	3, BtnCode			;{^3
	RETURN

unmatch1:
	;Oƕsv
	BANKSEL	BtnCnt
	CLRF	BtnCnt				;v񐔂Zbg
	MOVF	CurBtn, W			;݂̏Ԃۑ
	MOVWF	BefBtn
	RETURN

rels1:
	BCF		FlagBit, 0			;Ȃm莞,
	RETURN


; *****************************************
; ꂽ{^̔ԍo
;   ߒl R0L 0(Ȃ)/1`4({^ԍ)
; *****************************************
GetBtn:
	BANKSEL	BtnCode
	MOVFW	BtnCode		;->W
	CLRF	BtnCode		;NA
	RETURN


; *****************************************
; XibvXCb`̏Ԃo
;    W swԍ(0,1-4)
;   ߒl W 4bit or 0:OFF/1:ON
; *****************************************
GetSw:
	BANKSEL	tmp1
	MOVWF	tmp1
	CLRF	tmp2

	DECF	tmp1, F
	BZ		gs1			;SW1
	DECF	tmp1, F
	BZ		gs2			;SW2
	DECF	tmp1, F
	BZ		gs3			;SW3
	DECF	tmp1, F
	BZ		gs4			;SW4
	;
	; all
	BANKSEL	PORTB
;	COMF	PORTB, W
	MOVF	PORTB, W
	ANDLW	0x0F
	RETURN			;->W

gs1:
	BANKSEL	PORTB
	BTFSS	PORTB, SW1
	GOTO	gs12		;OFF
	;ON
	MOVLW	1
	RETURN
gs12:
	;OFF
	CLRW
	RETURN

gs2:
	BANKSEL	PORTB
	BTFSS	PORTB, SW2
	GOTO	gs12		;OFF
	;ON
	MOVLW	1
	RETURN

gs3:
	BANKSEL	PORTB
	BTFSS	PORTB, SW3
	GOTO	gs12		;OFF
	;ON
	MOVLW	1
	RETURN

gs4:
	BANKSEL	PORTB
	BTFSS	PORTB, SW4
	GOTO	gs12		;OFF
	;ON
	MOVLW	1
	RETURN


	END
