//
// }CR1 2 3C^[tF[Xp 17
//	copyright(c) T.Nakao 2007
//
// xK[EAvP[V
//

#case	// 啶ʂ

#include "main171.h"
#include <stdlib.h>
#include <string.h>
#include "..\Common\def877a.h"
#include "..\Common\reg877a.h"

#define ECHO_BACK						// CmdProcŃGR[obN
#include "..\Common\CommFunc.c"			// ʊ֐
#include "..\Common\LCD_custom.c"		// LCDhCo
#include "..\Common\I2CHM.c"			// I2Cn[hEFAE}X^EhCo


//*******************************************************************************
// TIMER1  20MHz/4 * 1/8 = 0.625MHz
// CCPR1=62500   0.625 / 62500 = 10Hz
//*******************************************************************************

// VAER}h
void SerCmdExec(void);

// v
bool OneSec = false;
BYTE SubSec = 0;
BYTE SubCount;

// L[͊֌W
bool KeyScanTiming = false;
BYTE KeyPeriod = 0;

// vg^Cv錾
BYTE ReadEEData(BYTE adrs);
void WriteEEData(BYTE adrs, BYTE data);
void WriteEEData2(BYTE adrs, BYTE data);
void SerCmdExec(void);
void DispMenu(void);
void SetCursor(void);
void MenuProc(void);
void ProcUPKey(void);
void ProcDOWNKey(void);
void ProcSELKey(void);
void ProcSELKey2(void);
void ProcENTKey(void);
char ScanKey(void);
void Cmd_Interval(BYTE intv);
void Cmd_Start(BYTE intv);
void Cmd_End(void);
void Cmd_Clear(void);
BYTE DumpProc(void);
void PutRecInfo(void);
void GetRecInfo(void);
void PutRecord(WORD ix);
void GetRecord(WORD ix);
WORD GetTemp(BYTE num);
BYTE GetAbsTmp(WORD temp, BYTE *minus);
void LCDClear(void);
void LCDString(char *str);
void LCDGotoXY(BYTE x, BYTE y);
void DispSLED(void);


BYTE Interval;					// EL^Ԋu()

bool MeasFlg = false;			// ^C~OtO
WORD MeasSecTmr = 0xFFFF;		// ^C}(b)
#define MES_FACTOR 60			// 莞ԌW 60b
//#define MES_FACTOR 1			// 莞ԌW 1b(for debug)


// PIC-EEPROMp[^ EEPROMAhX
#define ROM_VALID         0		// EEPROMe۔pf[^
#define ROM_Interval      1		// L^Ԋu()

// I2C-EEPROMp[^ EEPROMAhX
#define ROM2_TOP           0
#define ROM2_VALID         0		// EEPROMe۔pf[^
#define ROM2_RecTopPtr_H   2		// R[h̐擪|C^
#define ROM2_RecTopPtr_L   3		//
#define ROM2_RecPtr_H      4		// I2C-EEPROM L^f[^̃JgE|C^
#define ROM2_RecPtr_L      5		//
#define ROM2_RecCount_H    6		// I2C-EEPROM L^f[^̌
#define ROM2_RecCount_L    7		//
#define ROM2_RecNum_H      8		// I2C-EEPROM R[hA
#define ROM2_RecNum_L      9		//


// I2C-EEPROM L^p[^iobt@j
#define I2C_EEPROM_SIZE 8192	// I2C-EEPROM ROMe(24LC64)
#define REC_DATA_OFFSET	16		// I2C-EEPROM̋L^f[^̐擪ItZbg
#define REC_DATA_SIZE   8		// 1̋L^f[^̃oCg
// R[h̍őL^
#define REC_MAX_SIZE (I2C_EEPROM_SIZE - REC_DATA_OFFSET) / REC_DATA_SIZE

BYTE RomDataBuffer[REC_DATA_SIZE];	// I2C-EEPROM y[WECg,
									//   V[PVE[hpobt@
// I2C CBR/WtO
#define I2C_W 0
#define I2C_R 1

// I2CX[uEfoCXEAhX
#define I2C_EEPROM_ADRS 0x50		// 24LC64
#define I2C_TEMP1_ADRS  0x48		// LM75 #1
#define I2C_TEMP2_ADRS  0x49		// LM75 #2
#define I2C_SLED_ADRS   0x00		// 7ZOgl\

// I2C-EEPROM OEobt@
WORD RecTopPtr;						// ŏ̃R[hw|C^
WORD RecPtr;						// JgER[hw|C^
WORD RecCount;						// L^ς݃R[h
WORD RecNum;						// _R[hԍ

BYTE Temp1, Temp2;					// 艷x(8rbgΒl)
BYTE Sign1, Sign2;					// x̕(ture:}CiX)

BYTE MenuPtr = 0;
BYTE SubMenuPtr = 0;

BYTE AvrCnt = 0;
WORD AvrTmpSum1;
WORD AvrTmpSum2;

#define AVERAGE_COUNT 4				// xς̉Z

// LCDRg[(CCS-C)
#define LCD_CURSOR_BLINK_ON lcd_send_byte(0, 0b1101)
#define LCD_CURSOR_OFF      lcd_send_byte(0, 0b1100)

// L[EJEZX
#define TSTCOL1 !PB.B4
#define TSTCOL2 !PB.B5
#define TSTCOL3 !PB.B6
#define TSTCOL4 !PB.B7

// _v
bool DumpFlg = false;
WORD DumpIndex;					// _v(_)CfbNX(0org)
BYTE DumpCnt;					// _v
BYTE DumpCntC;					// _v
WORD DumpCnt2;

#define LED1 PC.B0
#define LED2 PC.B1


// *********************************************************************
// TIMER0 I[oEt[݃[`
//   TIMER0 f=20MHz/4 * 1/256 = 19.53KHz  t=51.2us T=51.2*256=13ms
// *********************************************************************
#int_RTCC
RTCC_isr() {
	KeyPeriod++;
	if(KeyPeriod == 2) {
		KeyScanTiming = true;		// 26ms
		KeyPeriod = 0;
	}
}


// *********************************************************************
// CCP1 RyAE}b`݃[`
// *********************************************************************
#int_CCP1
CCP1_isr() {
	SubCount++;
	if(SubCount >= 10) {
		SubCount = 0;			// 1s
		OneSec = true;
	}
}


// *********************************************************************
// VAEf[^M݃[`
// *********************************************************************
#int_RDA
RDA_isr() {
	if(RcvCnt < RXBUFSIZE) {
		// Mobt@ɂ܂󂫂Ƃ
		RcvBuf[RcvInPtr++] = getc();			// Mf[^Oobt@֊i[
		RcvCnt++;
		if(RcvInPtr >= RXBUFSIZE) {				// |C^̃bvAEh
			RcvInPtr = 0;
		}
	}
}


//
// PIC EEPROMǂݏo
//
BYTE ReadEEData(BYTE adrs) {
	EEADR = adrs;
	BitSet(EECON1, RD);
	return EEDATA;
}


//
// PIC EEPROM (҂Ȃ)
//
void WriteEEData(BYTE adrs, BYTE data) {
	EEADR = adrs;
	EEDATA = data;
	BitSet(EECON1, WREN);
	DI_GLOBAL;
	EECON2 = 0x55;
	EECON2 = 0xAA;
	BitSet(EECON1, WR);
	BitClr(EECON1, WREN);
	EI_GLOBAL;
}


//
// PIC EEPROM (҂)
//
void WriteEEData2(BYTE adrs, BYTE data) {

	WriteEEData(adrs, data);
	while(TST_EEWrite_NOT_DONE) {}		// ݊҂
}


// *********************************************************************
void main() {
	BYTE data;
	bool tmp_flag;				// xL

	ADCON1 = 0x06;				// ADC All digital
	lcd_init();					// LCD
	I2CMsInit();				// I2C}X^

	// TIMER0
	BitClr(OPTION_REG, NOT_RBPU);	// RB pullup enable
	BitClr(OPTION_REG, T0CS);
	BitClr(OPTION_REG, PSA);
	BitSet(OPTION_REG, PS2);		// TMR0vXP[1/256
	BitSet(OPTION_REG, PS1);
	BitSet(OPTION_REG, PS0);

	// CCP1&TIMER1 RyAE[h
	// CCP1 RyA[h INT/reset TMR1
	BitSet(CCP1CON, 3);			// CCP1M3-CCP1M0
	BitClr(CCP1CON, 2);			//   = (1011)
	BitSet(CCP1CON, 1);			//
	BitSet(CCP1CON, 0);			//

	// TIMER1̐ݒ
	BitSet(T1CON, T1CKPS1);		// T1CKPS1-0 = (11)
	BitSet(T1CON, T1CKPS0);		//   vXP[ 1/8
	BitClr(T1CON, TMR1CS);		// Fosc/4

	// EEPROM̓ǂݏo
	if(ReadEEData(ROM_VALID) == 0x27) {				// EEPROMe۔pf[^
		// PIC-EEPROM̓eL
		Interval  =  ReadEEData(ROM_Interval);		// L^Ԋu()
	} else {
		// PIC-EEPROM̓e ftHglݒ
		Interval  = 10;
		WriteEEData2(ROM_Interval, Interval);
		WriteEEData2(ROM_VALID, 0x27);				// PIC-EEPROMf[^L
	}

	// L^p[^I2C-EEPROM擾(܂̓ftHglݒ)
	GetRecInfo();

	// I/O|[g̏
	BitClr(TRISC, 0);				// RC0:LED1
	BitClr(TRISC, 1);				// RC1:LED2
	TRISB = 0xFF;					// XCb` all input

	LED1 = 0;						// LED1 OFF
	LED2 = 0;						// LED2 OFF

	SubCount = 0;

	TIMER1_OFF;						// TIMER1~
	TMR1L = 0;
	TMR1H = 0;
	CCPR1L = 62500;					// CCP1RyAl
	CCPR1H = 62500 >> 8;
	CLR_CCP1IF;
	TIMER1_ON;						// TIMER1쓮
	OneSec = false;

	// 荞݋
	EI_CCP1;						// CCP1荞
	EI_TMR0;						// TIMER0I[ot[荞
	EI_RC;							// VAM荞
	EI_PERIP;
	EI_GLOBAL;

	// ŏ̉x\
	AvrTmpSum1 = GetTemp(0);
	AvrTmpSum2 = GetTemp(1);

	delay_ms(100);

	AvrTmpSum1 = GetTemp(0);
	AvrTmpSum2 = GetTemp(1);

	Temp1 = GetAbsTmp(AvrTmpSum1, &Sign1);
	Temp2 = GetAbsTmp(AvrTmpSum2, &Sign2);
	AvrTmpSum1 = 0;
	AvrTmpSum2 = 0;

	DispMenu();				// AxȂǕ\

	// ******************** CE[v ********************
	while(1) {
		if(OneSec) {
			// 1b̏
			OneSec = false;
			if(MenuPtr != 1) {
				// vݒ蒆ł͂ȂƂ
				UpdateClock2();			// vXV
			}

			// xǂݏo
			AvrTmpSum1 += GetTemp(0);
			AvrTmpSum2 += GetTemp(1);
			AvrCnt++;
			if(AvrCnt == AVERAGE_COUNT) {
				AvrCnt = 0;
				AvrTmpSum1 /= AVERAGE_COUNT;				// ς߂
				AvrTmpSum2 /= AVERAGE_COUNT;
				Temp1 = GetAbsTmp(AvrTmpSum1, &Sign1);		// ωxm
				Temp2 = GetAbsTmp(AvrTmpSum2, &Sign2);		//
				AvrTmpSum1 = 0;
				AvrTmpSum2 = 0;
			}

			// AL^
			if(MeasSecTmr != 0xFFFF) {
				// ^C}쓮
				MeasSecTmr--;
				if(MeasSecTmr == 0) {
					// ^C~O
					MeasFlg = true;
					// ^C}Đݒ
					// (bZ)
					MeasSecTmr = (WORD)Interval * MES_FACTOR;
				}
			}

			if(MeasFlg) {
				// L^^C~O
				MeasFlg = false;

				// R[hA
				RomDataBuffer[0] = RecNum >> 8;		// 8rbg
				RomDataBuffer[1] = (BYTE)RecNum;	// 8rbg
				RecNum++;							// _R[hԍ

				// Jgx(ϒl)
				RomDataBuffer[6] = Temp1;
				RomDataBuffer[7] = Temp2;

				data = 0;
				if(Sign1) {
					// }CiX
					data |= 0x80;				// b7
				}
				if(Sign2) {
					// }CiX
					data |= 0x40;				// b6
				}

				// ݎo
				RomDataBuffer[2] = Day;
				RomDataBuffer[3] = Hour;
				RomDataBuffer[4] = Min;
				RomDataBuffer[5] = Sec | data;	// signrbg

				// L^ I2C-EEPROM֕ۑ
				PutRecord(RecPtr);
				RecCount++;						// R[hXV
				if(RecCount >= REC_MAX_SIZE) {
					// obt@tŏ񂾂Ƃ _␳
					// 1i߂
					// RecTopPtr = (RecTopPtr + 1) % REC_MAX_SIZE; CCS-C BUG
					RecTopPtr++;
					if(RecTopPtr >= REC_MAX_SIZE) {
						RecTopPtr = 0;
					}
					RecCount--;
					// R[h͍őlێ
				}
				// R[h̃Jg|C^XV
				// RecPtr = (RecPtr + 1) % REC_MAX_SIZE; CCS-C BUG
				RecPtr++;
				if(RecPtr >= REC_MAX_SIZE) {
					RecPtr = 0;
				}
			}

			if(MenuPtr == 0) {
				// ʏ\̂Ƃ
				DispMenu();				// AxȂǕ\
			}
		}
		// 1b̏I

		// VAM
		if(GetRxData(&data)) {
			// VAf[^M
			CmdProc(data);			// R}h,s
		}

		// L[͏
		if(KeyScanTiming) {			// 26ms
			KeyScanTiming = false;
			if(ScanKey()) {
				MenuProc();
			}
		}

		// L^f[^_v
		if(DumpFlg) {
			DumpProc();				// _vR}hs
		}
	}
}


//
// R}h zXgMR}hɉs
//
void SerCmdExec(void) {
	BYTE cmd;
	BYTE buf[8];			// Ɨpobt@

	cmd = toupper(CmdBuf[0]);
	switch(cmd) {
		case 'T':			// vݒR}h
			if(strlen(CmdBuf) == 7) {
				buf[0] = CmdBuf[1];
				buf[1] = CmdBuf[2];
				buf[2] = 0;
				Hour = atoi(buf);

				buf[0] = CmdBuf[3];
				buf[1] = CmdBuf[4];
				Min = atoi(buf);

				buf[0] = CmdBuf[5];
				buf[1] = CmdBuf[6];
				Sec = atoi(buf);

				// eJE^̒[Zbg
				DI_GLOBAL;
				TMR1L = 0;
				TMR1H = 0;
				SubSec = 0;
				SubCount = 0;
				EI_GLOBAL;
			} else {
				printf("?\r\n");	// R}hEtH[}bgُ
				return;
			}
			break;

		case 'S':			// JnR}h(OK)
			if(strlen(CmdBuf) == 3) {
				// p[^
				buf[0] = CmdBuf[1];
				buf[1] = CmdBuf[2];
				buf[2] = 0;
				Interval = atoi(buf);			// C^[o
			}
			Cmd_Start(Interval);

			break;

		case 'E':			// IR}h(OK)
			Cmd_End();
			break;

		case 'D':			// _vER}h
			if(strlen(CmdBuf) == 7) {
				// p[^
				buf[0] = CmdBuf[1];
				buf[1] = CmdBuf[2];
				buf[2] = CmdBuf[3];
				buf[3] = CmdBuf[4];
				buf[4] = 0;
				DumpIndex = atoi(buf);			// _vCfbNX(0org)

				buf[0] = CmdBuf[5];
				buf[1] = CmdBuf[6];
				buf[2] = 0;
				DumpCnt = atoi(buf);			// _v
				DumpCntC = DumpCnt;
				DumpCnt2 = RecCount;			// SR[h

				// _vJn
				DumpFlg = true;
				return;
			} else if(strlen(CmdBuf) == 1) {
				// p[^Ȃ OĨp[^p
				DumpIndex++;
				DumpCnt = DumpCntC;
				// _vJn
				DumpFlg = true;
				return;
			} else {
				printf("?\r\n");				// p[^G[
			}
			break;

		case 'C':			// obt@NAER}h(OK)
			Cmd_Clear();					// obt@񏉊
			break;

		case 'N':			// f[^₢킹
			printf("%ld\r\n", RecCount);
			return;

		case 'I':			// C^[oԐݒ
			if(strlen(CmdBuf) == 3) {
				buf[0] = CmdBuf[1];
				buf[1] = CmdBuf[2];
				buf[2] = 0;
				Interval = atoi(buf);	// C^[o
				Cmd_Interval(Interval);
			}
			break;

		default:
			printf("?\r\n");	// R}hYȂ
			return;
	}
	printf("OK\r\n");			// R}ht
}


//
// AxAݒ荀ځAݒlȂǂLCD\
//
void DispMenu(void) {
	char str_buf[17];
	WORD tmp;
	BYTE tmp1, tmp2, tmp11, tmp12;

	switch(MenuPtr) {
		case 0:				// ʏ\ ݎ, x1,2, L^
			LCDClear();
			LCD_CURSOR_OFF;

//			sprintf(str_buf, "%03d  %02d:%02d:%02d", Day, Hour, Min, Sec);
			sprintf(str_buf, "%02d %02d:%02d:%02d %2d", Day, Hour, Min, Sec, (BYTE)RecCount);
			LCDString(str_buf);
			LCDGotoXY(0, 1);		// 2s

			tmp = (WORD)Temp1 * 5;
			tmp1 = (BYTE)(tmp / 10);
			tmp2 = (BYTE)(tmp % 10);

			tmp = (WORD)Temp2 * 5;
			tmp11 = (BYTE)(tmp / 10);
			tmp12 = (BYTE)(tmp % 10);

			// Ȃ̉x̕
			sprintf(str_buf, "%3d.%d%cC %3d.%d%cC",
						tmp1, tmp2, 0xDF, tmp11, tmp12, 0xDF);

			// 
			if(Sign1) {
				// X_
				str_buf[0] = '-';
			}
			if(Sign2) {
				// X_
				str_buf[8] = '-';
			}
			LCDString(str_buf);

			DispSLED();				// I2Cl\ \
			return;

		case 1:				// vݒ
			LCDClear();
			lcd_putc("TIME");
			sprintf(str_buf, "%02d:%02d:%02d", Hour, Min, Sec);
			break;
		case 2:				// Ԋuݒ
			LCDClear();
			lcd_putc("INTERVAL");
			sprintf(str_buf, "%3u", Interval);
			break;
		case 3:				// obt@NAmF
			LCDClear();
			lcd_putc("BUF CLR?");
			sprintf(str_buf, "YES:ENT");
			break;
		default:
			return;
	}

	LCDGotoXY(0, 1);		// 2sڂ̐擪
	LCDString(str_buf);
	LCD_CURSOR_BLINK_ON;
	SetCursor();
}


//
// J[\ʒuݒ
//
void SetCursor(void) {
	switch(MenuPtr) {
		case 0:				// ʏ펞
			break;
		case 1:				// vݒ
			switch(SubMenuPtr) {
				case 0:				// 
					//  ʒuɃJ[\ړ
					LCDGotoXY(1, 1);
					break;
				case 1:				// 
					//  ʒuɃJ[\ړ
					LCDGotoXY(4, 1);
					break;
				case 2:				// b
					// b ʒuɃJ[\ړ
					LCDGotoXY(7, 1);
					break;
				default:
					LCDGotoXY(1, 1);
					break;
			}
			break;
		case 2:				// Ԋuݒ
			LCDGotoXY(2, 1);
			break;
		case 3:				// obt@NAmF
			break;
	}
}


//
// L[͂ɉɐU蕪
//
void MenuProc(void) {

	switch(KPValue) {
		case 0:				// SEL
			ProcSELKey();
			break;
		case 1:				// UP
			ProcUPKey();
			break;
		case 2:				// DOWN
			ProcDOWNKey();
			break;
		case 3:				// ENT
			ProcENTKey();
			break;
		case 0x80:			// SEL
			ProcSELKey2();
			break;
	}
}


//
// UPL[̏
//
void ProcUPKey(void) {
	switch(MenuPtr) {
		case 0:				// ʏ펞 Jn
			Cmd_Start(Interval);
			break;

		case 1:				// vݒ蒆
			switch(SubMenuPtr) {
				case 0:				// 
					Hour = (Hour + 1) % 24;
					break;
				case 1:				// 
					Min = (Min + 1) % 60;
					break;
				case 2:				// b
					Sec = (Sec + 1) % 60;
					break;
			}
			break;
		case 2:				// Ԋuݒ蒆
			if(Interval < 255) {
				Interval++;
			}
			break;
	}
	DispMenu();
}


//
// DOWNL[̏
//
void ProcDOWNKey(void) {
	switch(MenuPtr) {
		case 0:				// ʏ풆 ~
			Cmd_End();
			break;

		case 1:				// vݒ蒆
			switch(SubMenuPtr) {
				case 0:				// 
					Hour = (Hour + 23) % 24;
					break;
				case 1:				// 
					Min = (Min + 59) % 60;
					break;
				case 2:				// b
					Sec = (Sec + 59) % 60;
					break;
			}
			break;
		case 2:				// Ԋuݒ蒆
			if(Interval > 1) {
				Interval--;
			}
			break;
	}
	DispMenu();
}


//
// SELL[̏(񒷉)
//
void ProcSELKey(void) {

	switch(MenuPtr) {
		case 0:				// ʏ\
			MenuPtr = 2;
			break;
		case 1:				// vݒ蒆
			SubMenuPtr = 0;
			MenuPtr = 0;	// ʏɖ߂
			break;
		case 2:				// Ԋuݒ蒆
			MenuPtr = 3;
			break;
		case 3:				// obt@NA(s)
			MenuPtr = 0;
			break;
	}
	DispMenu();
}


//
// SELL[̏
//
void ProcSELKey2(void) {
	if(MenuPtr == 0) {		// ʏ\
		MenuPtr = 1;		// vݒ胂[h
	}
	DispMenu();
}


//
// ENTL[̏
//
void ProcENTKey(void) {
	switch(MenuPtr) {
		case 1:				// vݒ蒆
			SubMenuPtr = (SubMenuPtr + 1) % 3;		// //b ύXڐ؂ւ
			DI_GLOBAL;								// 荞݋֎~
			TMR1L = 0;
			TMR1H = 0;
			SubCount = 0;
			CLR_CCP1IF;
			EI_GLOBAL;								// 荞݋
			break;
		case 2:				// Ԋuݒ蒆
			Cmd_Interval(Interval);					// m
			break;
		case 3:				// obt@ENA(mF)
			Cmd_Clear();							// obt@񏉊
			MenuPtr = 0;							// ʏɖ߂
			break;
	}
	DispMenu();
}


//
// L[EXL
//
char ScanKey(void) {
	BYTE key;

	if(TSTCOL4) {			// SW4(SEL)
		key = 0;
	} else if(TSTCOL3) {	// SW3(UP)
		key = 1;
	} else if(TSTCOL2) {	// SW2(DOWN)
		key = 2;
	} else if(TSTCOL1) {	// SW1(ENT)
		key = 3;
	} else {
		key = 0xFF;		// L[͂Ȃ
	}

	return KeyCheck2(key);
}


//
// R}hƂ̏
//

// C^[oԐݒ R}h
void Cmd_Interval(BYTE intv) {
	if(intv == 0) {
		intv = 10;							// ftHgl 10
	}
	Interval = intv;						// Ԋu m
	WriteEEData(ROM_Interval, Interval);	// EEPROM֋L^
	MenuPtr = 0;							// ʏɖ߂
}


// JnR}h
void Cmd_Start(BYTE intv) {
	if(intv == 0) {
		intv = 10;				// ftHgl 10
	}
	Interval = intv;			// Ԋu m

	Day = 0;					// JňoߓZbg

	// \tgEFAE^C} X^[g(Jn)
	MeasSecTmr = (WORD)Interval * MES_FACTOR;	// (bZ)
	MeasFlg = true;								// 1ڂ̑苖

	LED1 = 1;									// L^ LED1 ON
}


// IR}h
void Cmd_End(void) {
	MeasSecTmr = 0xFFFF;				// ^C}~
	MeasFlg = false;					// ֎~

	PutRecInfo();						// I2C-EEPROM R[hXV
	LED1 = 0;							// L^~ LED1 OFF
}


// obt@NAER}h (o^̂ݍXV)
void Cmd_Clear(void) {
	// ݂̃CfbNX擪ɂ
	RecTopPtr = RecPtr;
	// RecPtrEEPROM𖞕ՂȂg߂ɃNAȂ

	RecCount = 0;						// R[hZbg
	RecNum = 0;							// _R[hԍZbg
	Day = 0;							// JňoߓZbg

	PutRecInfo();						// I2C-EEPROM R[hXV
}


// L^f[^E_vER}h(C[vɓ)
BYTE DumpProc(void) {
	BYTE i, day, hour, min, sec;
	WORD ix, tmp;
	BYTE tmp1, tmp2;

	if(DumpIndex >= RecCount) {		// Jnԍ茏Ȃꍇ
		return false;				// p[^G[
	}

	ix = RecTopPtr + DumpIndex;

	// 5 VAM
	for(i = 0; i < 5; i++) {
		// IȊJnCfbNX߂
		//   (DumpIndexRecTopPtr擪Ƃ_IȃCfbNX)
		if(ix >= REC_MAX_SIZE) {
			ix = 0;
		}

		GetRecord(ix);						// ΏۃR[ho

//		printf("d%d,", DumpIndex);			// CfbNX
		day  = RomDataBuffer[2];			// oߓ
		hour = RomDataBuffer[3];			// 莞
		min  = RomDataBuffer[4];			//
		sec  = RomDataBuffer[5] & 0x3F;		//
		printf("%d,%02d:%02d:%02d,", day, hour, min, sec);	// VAM

		// x1
		if(RomDataBuffer[5] & 0x80) {
			// }CiXx
			putc('-');
		}
		tmp = (WORD)RomDataBuffer[6];			// x1
		tmp *= 5;								// 10~0.5
		tmp1  = (BYTE)(tmp / 10);				// 
		tmp2 = (BYTE)(tmp % 10);				// _ȉ
		printf("%d.%d,", tmp1, tmp2);			// VAM

		// x2
		if(RomDataBuffer[5] & 0x40) {
			// }CiXx
			putc('-');
		}
		tmp = (WORD)RomDataBuffer[7];			// x2
		tmp *= 5;								// 10~0.5
		tmp1  = (BYTE)(tmp / 10);				// 
		tmp2 = (BYTE)(tmp % 10);				// _ȉ
		printf("%d.%d\r\n", tmp1, tmp2);		// VAM

		DumpCnt--;
		DumpCnt2--;								// SR[h
		if((DumpCnt == 0) || (DumpCnt2 == 0)) {
			// McȂ
			DumpFlg = false;					// _vI
			return true;
		}
		ix++;								// ̃R[h
		DumpIndex++;
	}
	return true;
}


// R[hۑ
void PutRecInfo(void) {
	// I2C-EEPROMy[WECg
	I2CStart(0);								// STARTRfBV
	I2CWrite((I2C_EEPROM_ADRS << 1) | I2C_W);	// CB(W)
	I2CWrite(ROM2_TOP>>8);						// ROMAhX(H)
	I2CWrite(ROM2_TOP);							// ROMAhX(L)

	I2CWrite(0x27);				// 0 ROM2_VALID f[^L
	I2CWrite(0);				// 1 U[u

	// R[h̐擪|C^
	I2CWrite(RecTopPtr>>8); 	// 2 ROM2_RecTopPtr_H
 	I2CWrite(RecTopPtr);		// 3 ROM2_RecTopPtr_L

	// L^f[^̃JgE|C^
	I2CWrite(RecPtr>>8);		// 4 ROM2_RecPtr_H
	I2CWrite(RecPtr);			// 5 ROM2_RecPtr_L

	// L^f[^̌
	I2CWrite(RecCount>>8);		// 6 ROM2_RecCount_H
	I2CWrite(RecCount); 		// 7 ROM2_RecCount_L

	// _R[hԍ
	I2CWrite(RecNum>>8);		// 8 ROM2_RecNum_H
	I2CWrite(RecNum);			// 9 ROM2_RecNum_L

	I2CStop();					// STOPRfBV(EEPROM݊Jn)
	// 5msȓɑďނƂ͂Ȃ߁A݊͑҂Ȃ
}


// R[h擾
void GetRecInfo(void) {

	// I2C-EEPROMV[PVE[h
	I2CStart(0);								// STARTRfBV
	I2CWrite((I2C_EEPROM_ADRS << 1) | I2C_W);	// CB(W)
	I2CWrite(ROM2_TOP>>8);						// ROMAhX(H)
	I2CWrite(ROM2_TOP);							// ROMAhX(L)

	I2CStart(1);						// s[gSTARTRfBV
	I2CWrite((I2C_EEPROM_ADRS << 1) | I2C_R);	// CB(R)

	if(I2CRead(0) != 0x27) {		// 0 ROM2_VALID f[^L`FbN
		// ̂ƂftHglݒ
		RecTopPtr = 0;
		RecPtr    = 0;
		RecCount  = 0;
		RecNum    = 0;
		I2CStop();					// STOPRfBV

		PutRecInfo();				// ftHglEEPROM֕ۑ
	}  else {
		I2CRead(0);								// 1 U[u(ǂ)

		// R[h̐擪|C^
		RecTopPtr =  (WORD)I2CRead(0) << 8; 	// 2 ROM2_RecTopPtr_H
 	 	RecTopPtr |= (WORD)I2CRead(0);			// 3 ROM2_RecTopPtr_L

		// L^f[^̃JgE|C^
		RecPtr =  (WORD)I2CRead(0) << 8;		// 4 ROM2_RecPtr_H
		RecPtr |= (WORD)I2CRead(0);				// 5 ROM2_RecPtr_L

		// L^f[^̌
		RecCount =  (WORD)I2CRead(0) << 8;		// 6 ROM2_RecCount_H
		RecCount |= (WORD)I2CRead(0); 			// 7 ROM2_RecCount_L

		// _R[hԍ
		RecNum =  (WORD)I2CRead(0) << 8;		// 8 ROM2_RecNum_H
		RecNum |= (WORD)I2CRead(1);				// 9 ROM2_RecNum_L (NOACK)

		I2CStop();								// STOPRfBV
	}
}


//
// I2C-EEPROM f[^L^Aǂݏo
//

//
// RomDataBuffer[]̑f[^I2C-EEPROM̎wCfbNXʒu֏
//   ix: CfbNXԍ
//
void PutRecord(WORD ix) {
	WORD adrs;
	BYTE adrs_h, adrs_l;
	BYTE i;

	// ݐ擪AhX(I2C-EEPROM)
	adrs = REC_DATA_OFFSET + ix * REC_DATA_SIZE;
	adrs_l = adrs;
	adrs_h = adrs >> 8;

	// I2C-EEPROMy[WECg
	I2CStart(0);								// STARTRfBV
	I2CWrite((I2C_EEPROM_ADRS << 1) | I2C_W);	// CB(W)
	I2CWrite(adrs_h);							// ROMAhX(H)
	I2CWrite(adrs_l);							// ROMAhX(L)

	// f[^̑M
	for(i = 0; i < REC_DATA_SIZE; i++) {
		I2CWrite(RomDataBuffer[i]);

	}
	I2CStop();					// STOPRfBV(EEPROM݊Jn)
	// 5msȓɑďނƂ͂Ȃ߁A݊͑҂Ȃ
}


//
// I2C-EEPROM̎wCfbNXʒȗf[^RomDataBuffer[]֓ǂݏo
//   ix: CfbNXԍ
//
void GetRecord(WORD ix) {
	WORD adrs;
	BYTE adrs_h, adrs_l;
	BYTE i;

	// ǂݏo擪AhX(I2C-EEPROM)
	adrs = REC_DATA_OFFSET + ix * REC_DATA_SIZE;
	adrs_l = adrs;
	adrs_h = adrs >> 8;

	// I2C-EEPROMV[PVE[h
	I2CStart(0);								// STARTRfBV
	I2CWrite((I2C_EEPROM_ADRS << 1) | I2C_W);	// CB(W)
	I2CWrite(adrs_h);							// ROMAhX(H)
	I2CWrite(adrs_l);							// ROMAhX(L)

	I2CStart(1);						// s[gEX^[gERfBV
	I2CWrite((I2C_EEPROM_ADRS << 1) | I2C_R);	// CB(R)

	// f[^̎M
	for(i = 0; i < REC_DATA_SIZE - 1; i++) {
		RomDataBuffer[i] = I2CRead(0);			// ACK

	}
	// ŏIf[^
	RomDataBuffer[i] = I2CRead(1);				// NO ACK
	I2CStop();									// STOPRfBV
}



//
// I2Cxǂݏo
//

//
// w̉xZT牷xǂݏo. x͐Βlƕ
//   IN:  num ZTԍ(0,1)
//   RET: A/Dϊꂽxl(9bit 2̕␔)
//
WORD GetTemp(BYTE num) {
	WORD tmp;
	BYTE tmp_h, tmp_l;

	I2CStart(0);								// STARTRfBV
	if(num == 0) {
		I2CWrite((I2C_TEMP1_ADRS << 1) | I2C_R);	// CB(R) LM75 #1
	} else {
		I2CWrite((I2C_TEMP2_ADRS << 1) | I2C_R);	// CB(R) LM75 #2
	}
	tmp_h = I2CRead(0);							// x(H) ACK
	tmp_l = I2CRead(1);							// x(L) NOACK

	I2CStop();					// STOPRfBV(EEPROM݊Jn)

	tmp = (WORD)tmp_h;
	tmp <<= 1;
	if(tmp_l & 0x80) {			// xf[^LSB
		// LSB == 1
		tmp |= 0x01;
	}

	return tmp;
}


//
// Βlϊ
//   2̕␔lΒlƕɕ
//   IN:  2̕␔A/Dϊl(9rbg)
//   OUT: minus (true:/false:)
//   RET: Βl(8bit)
//
BYTE GetAbsTmp(WORD temp, BYTE *minus) {
	BYTE tmp;

	tmp = (WORD)temp;			// ȊO̕

	if(temp & 0x0100) {			// b8:rbg
		// 
		tmp = ~tmp + 1;			// (Βl)
		*minus = true;			// }CiXx
	} else {
		// 
		*minus = false;			// vXx
	}

	return tmp;					// Βl
}


void LCDClear(void) {
	lcd_putc('\f');
}


//
// LCD\
//
void LCDString(char *str) {
	while(*str != 0) {
		lcd_putc(*str);
		str++;
	}
}


//
// LCDJ[\ʒuݒ
//
void LCDGotoXY(BYTE x, BYTE y) {
	lcd_gotoxy(x + 1, y + 1);
}


// 7ZOg l\ \  061215
void DispSLED(void) {
	BYTE dig1, dig2;

	I2CStart(0);
	I2CWrite((I2C_SLED_ADRS << 1) | I2C_W);

	I2CWrite(0x68 | 1);		// _\(1)
	I2CWrite(0x68 | 3);		// _\(3)
	I2CWrite(0x45);			// JgE|C^=0

	dig1 = Hour / 10;		// 10̈
	dig2 = Hour % 10;		// 1̈
	I2CWrite(dig1);			// 
	I2CWrite(dig2);

	dig1 = Min / 10;		// 10̈
	dig2 = Min % 10;		// 1̈
	I2CWrite(dig1);			// 
	I2CWrite(dig2);

	dig1 = (Sec & 0x3F) / 10;		// 10̈
	dig2 = (Sec & 0x3F) % 10;		// 1̈
	I2CWrite(dig1);			// b
	I2CWrite(dig2);

	I2CStop();
}

