//
// }CR1 2 3C^[tF[Xp 18
//	copyright(c) T.Nakao 2007
//
// obeEj^EAvP[V
//

#case	// 啶ʂ

#include "main181.h"
#include <stdlib.h>
#include <string.h>
#include "..\Common\def877a.h"
#include "..\Common\reg877a.h"

#include "..\Common\CommFunc.c"			// ʊ֐
#include "..\Common\LCD_custom.c"		// LCDhCo
#include "..\Common\OW.c"				// 1-Wire\tgEFAE}X^EhCo


//*******************************************************************************
// TIMER1  20MHz/4 * 1/8 = 0.625MHz
// CCPR1=62500   0.625MHz / 62500 = 10Hz
//*******************************************************************************

// v
bool OneSec = false;
BYTE SubCount;

// L[͊֌W
bool KeyScanTiming = false;
BYTE KeyPeriod = 0;

// vg^Cv錾
void KeyProc(void);
char ScanKey(void);
void LCDClear(void);
void LCDString(char *str);
void LCDGotoXY(BYTE x, BYTE y);

// Hwlϊ, \񐶐
void GetVoltStr(WORD data);
void GetAmpStr(WORD data);
void GetAmpHurStr(WORD data);
void GetTempStr(WORD data);

// [d^C}XV
void UpdateTimer(void);

// \pobt@
char str_buf[16];

bool LedSts = false;

// LCDRg[(CCS-C)
#define LCD_CURSOR_BLINK_ON lcd_send_byte(0, 0b1101)
#define LCD_CURSOR_OFF      lcd_send_byte(0, 0b1100)

// L[EJEZX
#define TSTCOL1 !PB.B4
#define TSTCOL2 !PB.B5
#define TSTCOL3 !PB.B6
#define TSTCOL4 !PB.B7

#define LED1  PC.B0
#define LED2  PC.B1
//#define RELAY PA.B4
#define RELAY PC.B0

#define SW21 PB.B0		// gOXCb`(E[)
#define SW22 PB.B1		// gOXCb`
#define SW23 PB.B2		// gOXCb`
#define SW24 PB.B3		// gOXCb`([)  [d[hON/OFF


// *********************************************************************
// TIMER0 I[oEt[݃[`
//   TIMER0 f=20MHz/4 * 1/256 = 19.53KHz  t=51.2us T=51.2*256=13ms
// *********************************************************************
#int_RTCC
RTCC_isr() {
	KeyPeriod++;
	if(KeyPeriod == 2) {
		KeyScanTiming = true;		// 26ms
		KeyPeriod = 0;
	}
}


// *********************************************************************
// CCP1 RyAE}b`݃[`
// *********************************************************************
#int_CCP1
CCP1_isr() {
	SubCount++;
	if(SubCount >= 10) {
		SubCount = 0;			// 1s
		OneSec = true;
	}
}


// *********************************************************************
void main() {
	BYTE data;
	bool tmp_flag;				// xL
	BYTE dat_h, dat_l;
	WORD  wdata;

	ADCON1 = 0x06;				// ADC All digital

	lcd_init();					// LCD
	OWInit();					// 1-Wire}X^

	// TIMER0
	BitClr(OPTION_REG, NOT_RBPU);	// RB pullup enable
	BitClr(OPTION_REG, T0CS);
	BitClr(OPTION_REG, PSA);
	BitSet(OPTION_REG, PS2);		// TMR0vXP[1/256
	BitSet(OPTION_REG, PS1);
	BitSet(OPTION_REG, PS0);

	// CCP1&TIMER1 RyAE[h
	// CCP1 RyA[h INT/reset TMR1
	BitSet(CCP1CON, 3);			// CCP1M3-CCP1M0
	BitClr(CCP1CON, 2);			//   = (1011)
	BitSet(CCP1CON, 1);			//
	BitSet(CCP1CON, 0);			//

	// TIMER1̐ݒ
	BitSet(T1CON, T1CKPS1);		// T1CKPS1-0 = (11)
	BitSet(T1CON, T1CKPS0);		//   vXP[ 1/8
	BitClr(T1CON, TMR1CS);		// Fosc/4

	// I/O|[g̏
	BitClr(TRISC, 0);				// RC0:LED1
	BitClr(TRISC, 1);				// RC1:LED2
	TRISB = 0xFF;					// XCb` all input

	BitClr(TRISA, 4);				// RA4 output
	TRISB = 0xFF;					// PORTBׂē

	LED1 = 0;						// LED1 OFF
	LED2 = 0;						// LED2 OFF

	SubCount = 0;
	OneSec = false;

	TIMER1_OFF;						// TIMER1~
	TMR1L = 0;
	TMR1H = 0;
	CCPR1L = 62500;					// CCP1RyAl
	CCPR1H = 62500 >> 8;
	CLR_CCP1IF;
	TIMER1_ON;						// TIMER1쓮

	RELAY = 1;						// [ON

	// 荞݋
	EI_CCP1;						// CCP1荞
	EI_TMR0;						// TIMER0I[ot[荞
	EI_PERIP;
	EI_GLOBAL;

	LCD_CURSOR_OFF;

	// ******************** CE[v ********************
	while(1) {
		if(OneSec) {
			// 1b̏
			OneSec = false;

			UpdateTimer();			// ^C}XV

			LCDClear();

			//------------------------------------------
			DI_GLOBAL;				// 荞݋֎~

			// 1-Wire oXEZbg
			OWBusReset();

			// SKIP ROM R}h
			OWWriteByte(0xCC);		// SKIP ROMR}hM

			// dǂݏo
			OWWriteByte(0x69);			// R}hM
			OWWriteByte(0x0E);			// READ擪AhX
			dat_h = OWReadByte();		// dl 8rbg
			dat_l = OWReadByte();		// dl 8rbg

			EI_GLOBAL;				// 荞݋

			wdata = ((WORD)dat_h << 8) | dat_l;
			GetAmpStr(wdata);

			LCDString(str_buf);

			//------------------------------------------
			DI_GLOBAL;				// 荞݋֎~

			// 1-Wire oXEZbg
			OWBusReset();

			// SKIP ROM R}h
			OWWriteByte(0xCC);		// SKIP ROMR}hM

			// dǂݏo
			OWWriteByte(0x69);			// R}hM
			OWWriteByte(0x0C);			// READ擪AhX
			dat_h = OWReadByte();		// dl 8rbg
			dat_l = OWReadByte();		// dl 8rbg

			EI_GLOBAL;					// 荞݋

			wdata = ((WORD)dat_h << 8) | dat_l;

			// dId̃`FbN
			wdata >>= 5;
			if(wdata <= 553) {			// 2.7V(dId)ȉ
				RELAY = 0;				// obeՒf
			}

			GetVoltStr(wdata);			// d̕擾
			LCDGotoXY(9, 0);
			LCDString(str_buf);

			//------------------------------------------
			DI_GLOBAL;				// 荞݋֎~

			// 1-Wire oXEZbg
			OWBusReset();

			// SKIP ROM R}h
			OWWriteByte(0xCC);		// SKIP ROMR}hM

			// d͓ǂݏo
			OWWriteByte(0x69);			// R}hM
			OWWriteByte(0x10);			// READ擪AhX
			dat_h = OWReadByte();		// d͒l 8rbg
			dat_l = OWReadByte();		// d͒l 8rbg

			EI_GLOBAL;					// 荞݋

			wdata = ((WORD)dat_h << 8) | dat_l;
			GetAmpHurStr(wdata);		// d͂̕擾
			LCDGotoXY(0, 1);
			LCDString(str_buf);

			if(SW24) {
				// j^E[h(d)
				//------------------------------------------
				DI_GLOBAL;				// 荞݋֎~

				// 1-Wire oXEZbg
				OWBusReset();

				// SKIP ROM R}h
				OWWriteByte(0xCC);		// SKIP ROMR}hM

				// xǂݏo
				OWWriteByte(0x69);			// R}hM
				OWWriteByte(0x18);			// READ擪AhX
				dat_h = OWReadByte();		// d͒l 8rbg
				dat_l = OWReadByte();		// d͒l 8rbg

				EI_GLOBAL;				// 荞݋

				wdata = ((WORD)dat_h << 8) | dat_l;
				GetTempStr(wdata);				// x̕擾
				LCDGotoXY(9, 1);
				LCDString(str_buf);
			} else {
				// [d[h
				sprintf(str_buf, "%02d%02d%02d", Hour, Min, Sec);
				LCDGotoXY(9, 1);
				LCDString(str_buf);
			}

			// n[hr[gLED_
			if(!LedSts) {
				LED2 = 1;
			} else {
				LED2 = 0;
			}
			LedSts = !LedSts;
		}
		// 1b̏I

		// L[͏
		if(KeyScanTiming) {			// 26ms
			KeyScanTiming = false;
			if(ScanKey()) {
				KeyProc();
			}
		}
	}
}


//
// L[͂ɉ
//
void KeyProc(void) {

	switch(KPValue) {
		case 0:				// SW14
			if(SW24) {
				// j^[h
				// őeʂɃvZbg
				DI_GLOBAL;				// 荞݋֎~

				// 1-Wire oXEZbg
				OWBusReset();

				// SKIP ROM R}h
				OWWriteByte(0xCC);			// SKIP ROMR}hM

				// ~ϓd̓vZbg
				OWWriteByte(0x6C);			// WRITER}hM
				OWWriteByte(0x10);			// WRITE擪AhX

				// 1000mAh/0.25mA = 4000(0x0FA0)
				OWWriteByte(0x0F);			// vZbgf[^()Write
				OWWriteByte(0xA0);			// vZbgf[^()Write
				EI_GLOBAL;					// 荞݋
			} else {
				// [d[h
				// [dJn
				RELAY = 1;					// ON
				MinClock = 16*60;			// [d16
				Hour = 16;					// 16:00:00
				Min = 0;
				Sec = 0;
			}
			break;
		case 1:				// SW13
			if(SW24) {
				// j^[h
				// eʂ0ɃZbg
				DI_GLOBAL;					// 荞݋֎~

				// 1-Wire oXEZbg
				OWBusReset();

				// SKIP ROM R}h
				OWWriteByte(0xCC);			// SKIP ROMR}hM

				// ~ϓd̓vZbg
				OWWriteByte(0x6C);			// WRITER}hM
				OWWriteByte(0x10);			// WRITE擪AhX

				// 0mAh
				OWWriteByte(0x00);			// vZbgf[^()Write
				OWWriteByte(0x00);			// vZbgf[^()Write
				EI_GLOBAL;					// 荞݋
			}
			break;
		case 2:				// SW12
			RELAY = 0;
			break;
		case 3:				// SW11
			RELAY = 1;
			break;
	}
}


//
// L[EXL
//
char ScanKey(void) {
	BYTE key;

	if(TSTCOL4) {			// SW4(SEL)
		key = 0;
	} else if(TSTCOL3) {	// SW3(UP)
		key = 1;
	} else if(TSTCOL2) {	// SW2(DOWN)
		key = 2;
	} else if(TSTCOL1) {	// SW1(ENT)
		key = 3;
	} else {
		key = 0xFF;		// L[͂Ȃ
	}

	return KeyCheck(key, KEY_REPEAT_DIS);
}


//
// LCD\NA
//
void LCDClear(void) {
	lcd_putc('\f');
}


//
// LCD\
//
void LCDString(char *str) {
	while(*str != 0) {
		lcd_putc(*str);
		str++;
	}
}


//
// LCDJ[\ʒuݒ
//
void LCDGotoXY(BYTE x, BYTE y) {
	lcd_gotoxy(x + 1, y + 1);
}


//
// d Hwlϊ 擾
//
void GetVoltStr(WORD data) {
	WORD a, b, b1, c ,d;

	a = data / 100;			// 100̌̐l
	b = data % 100;			// 100̐l

	a *= 488;
	b *= 488;				// 1LSB=4.88mV
	b1 = b / 100;
	b = b % 100;
	a = a + b1;

	c = a / 1000;
	d = (a % 1000) / 100;

//	sprintf(str_buf, "%ld.%02ldmV", a, b);
	sprintf(str_buf, "%ld.%ldV", c, d);
}


//
// d Hwlϊ 擾
//
void GetAmpStr(WORD data) {
	WORD a, b, b1, c ,d;
	bool sign;

	if(data & 0x8000) {
		// 
		data = (data >> 3) | 0xE000;	// g
		data = ~data + 1;				// Βl
		sign = true;
	} else {
		data >>= 3;
		sign = false;
	}

	a = data / 100;
	b = data % 100;

	a *= 625;					// 1LSB=0.625mA
	b *= 625;
	b1 = b / 100;
//	b = b % 100;
	a = a + b1;

	c = a / 10;
//	d = a % 10;

	if(sign) {
		// 
		// sprintf(str_buf, "%ld.%ld%02ld", c, d, b);
		// sprintf(str_buf, "-%ld.%ldmA", c, d);
		sprintf(str_buf, "-%04ldmA", c);
	} else {
		// 
		// sprintf(str_buf, "%ld.%ldmA", c, d);
		sprintf(str_buf, " %04ldmA", c);
	}
}


//
// c(~ϓd) Hwlϊ 擾
//
void GetAmpHurStr(WORD data) {
	WORD a, b, b1, c ,d;
	bool sign;

	if(data & 0x8000) {
		// 
		data = ~data + 1;				// Βl
		sign = true;
	} else {
		sign = false;
	}

	a = data / 100;
	b = data % 100;

	a *= 25;
	b *= 25;				// 1LSB=0.25mAh
	b1 = b / 100;
	b = b % 100;
	a = a + b1;

	if(sign) {
		// (ߕd)
		sprintf(str_buf, "-%04ldmAh", a);
	} else {
		// 
		sprintf(str_buf, " %04ldmAh", a);
	}
}


//
// x Hwϊ 擾
//
void GetTempStr(WORD data) {
	WORD a, b, b1, c ,d;

	data >>= 5;

	a = data / 100;			// 100̌̐l 1000{l
	b = data % 100;			// 100̐l

	a *= 125;
	b *= 125;				// 1LSB=0.125
	b1 = b / 100;
//	b = b % 100;
	a = a + b1;
	c = a / 10;
	d = a % 10;

	sprintf(str_buf, "%ld.%ld%cC", c, d, 0xDF);
}


//
// [d^C}̃_EJEg
//
void UpdateTimer(void) {
	if(MinClock == 0) {
		return;					// ^C}~̂Ƃ
	}

	// vXV
	if(Sec > 0 ) {
		Sec--;
	} else {
		// XV
		Sec = 59;
		if(Min > 0) {
			Min--;
		} else {
			// XV
			Min = 59;
			if(Hour > 0) {
				Hour--;
			} else {
				Hour = 23;
			}
		}

		// ^CAbṽ`FbN
		if(MinClock > 0) {
			// ^C}쓮̂Ƃ
			MinClock--;
			if((MinClock == 0) && !SW24) {
				// [dŃ^CAbvƂ
				RELAY = 0;
				Hour = 0;
				Min = 0;
				Sec = 0;
			}
		}
	}
}

