//
// }CR1 2 3C^[tF[Xp
//	copyright(c) T.Nakao 2007
//
//	SPIn[hEFA}X^^X[uEhCo
//

#define WAIT_SSPIF while(!TST_SSPIF){}				   // SSPIFZbg҂

// void SPIMsInit(void);
// BYTE SPIMsCom(BYTE txdat);
// void SPISlInit(void);
// BYTE SPISlCom(BYTE *comdat);

// SPI|[g
#define bitSCK	3		// RC3
#define bitSDI	4		// RC4
#define bitSDO	5		// RC5
#define bitSS	5		// RA5


//****************************************
// SPI}X^(MSSPgp)
//****************************************
void SPIMsInit(void) {
	BitClr(SSPCON, SSPM3);		// SSPM3-0:0001
	BitClr(SSPCON, SSPM2);
	BitClr(SSPCON, SSPM1);
	BitSet(SSPCON, SSPM0);

	BitClr(SSPSTAT, SMP);
	BitClr(SSPSTAT, CKE);

	BitClr(SSPCON, CKP);
	BitSet(SSPCON, SSPEN);		// MSSP enable(ŌɎs邱)

	BitClr(TRISC, bitSCK);		// clock output
	BitSet(TRISC, bitSDI);
	BitClr(TRISC, bitSDO);
	BitClr(TRISA, bitSS);

	BitSet(PORTA, bitSS);

	BitClr(SSPCON, WCOL);
	BitClr(SSPCON, SSPOV);
}


//****************************************
// SPI}X^M(MSSPgp)
//  IN:  txdat }X^Mf[^
//  RET: SPIRxData }X^Mf[^
//****************************************
BYTE SPIMsCom(BYTE txdat) {
	BYTE rxdat;

	SSPBUF = txdat;			// }X^Mf[^ݒ, MJn
	WAIT_SSPIF;				// SSPIFZbg(ʐM)҂
	rxdat = SSPBUF;			// }X^Mf[^o
	CLR_SSPIF;

	return rxdat;
}


//****************************************
// SPIX[u(MSSPgp)
//****************************************
void SPISlInit(void) {
	BitClr(SSPCON, SSPM3);		// SSPM3-0:0101
	BitSet(SSPCON, SSPM2);
	BitClr(SSPCON, SSPM1);
	BitSet(SSPCON, SSPM0);

	BitClr(SSPSTAT, SMP);
	BitClr(SSPSTAT, CKE);

	BitClr(SSPCON, CKP);
	BitSet(SSPCON, SSPEN);		// MSSP enable(ŌɎs邱)

	BitSet(TRISC, bitSCK);		// clock input
	BitSet(TRISC, bitSDI);
	BitClr(TRISC, bitSDO);
	BitSet(TRISA, bitSS);

	BitClr(SSPCON, WCOL);
	BitClr(SSPCON, SSPOV);

	SSPBUF = 0;					// ԏ߂ɑM_~[f[^ݒ
}


//****************************************
// SPIX[uM(MSSPgp)
//   IN:  &comdat X[uMf[^
//   OUT: &comdat X[uMf[^
//   RET: true:ʐM / false:ʐMȂ
//****************************************
BYTE SPISlCom(BYTE *comdat) {
	BYTE rxdat;
	// SSPIFZbg(ʐM)҂ ĂȂƂ͂ɏI
	if(!TST_SSPIF) {
		return false;
	}

	rxdat = SSPBUF;			// Mf[^o
	SSPBUF = *comdat;		// ̑Mf[^pӂĎ̎Mɔ
	CLR_SSPIF;

	*comdat = rxdat;		// Mf[^ݒ
	return true;
}
